<?php
/*****************************
* Copyright 2016, 2017, 2018, 2019, 2021 1st Source IT, LLC
* All rights reserved.
* Permission granted for use as
* long as this copyright notice, associated text and
* links remain in tact.
* Licensed for a single domain and a single instance of EZ-cart.
* Additional licenses can be purchased for additonal sites.
*
* http://www.ez-ms.com
* http://www.ez-om.com
* http://www.1sit.com*
*
* End copyright notification
*/

// Config params for this addon
$x = explode(DIRECTORY_SEPARATOR, dirname(__FILE__));
$config_addon_name = $x[count($x)-1];
$addon_min_ver = '4';		// Force version 4 updates only
$addon_cur_ver = '4.15.27';	
/* 4.3.1 - 6/9/16 	- Basic capture functionality
 * 4.3.2 - 7/8/16 	- Added Capture, Void and Refund capability
 * 4.3.3 - 7/10/16 	- Changed format of pay_info data to support future 
 *						extra transactions
 * 4.3.4 - 7/16/16 	- Added "additional transactions" and specific 
 *						Capture, Void and Refund.
 * 4.3.5 - 7/25/16	-  Minor bug fixes related to display in payment_info 
 *						admin orders.view
 * 4.3.6 - 8/2/16	- Fixed issue on form genertion when first in list or 
 *						upon second payment method access.
 * 4.3.7 - 10/28/16	- Improved handling of unknown location nickname
 * 					- fixed issue regarding DELETE http arguments (no data 
 *						argument like all the others)
 * 					- added user_id check with auth before allowing card 
 *						delete.
 * 					- fixed issue on admin orders.details page where hidden 
 *						fields were set to be required which prevented the 
 *						Save changes button from actuating.
 * 					- added setup instructions for Squareup.com
 * 4.3.9 = 11/6/16	- Corrections to admin template to use $order_info.user_id
 *						instead of $auth.user_id  (Note that 4.3.7 was 
 *						released as 4.3.8 inadvertently, hence 4.3.9
 * 4.4.10 - 11/29/16 - Fix to Always save card
 *					 - Change order of input fields to match card order
 *					 - several bug fixes to improve error handling
 *					 - when always save cards is selected, don't use 
 *						encrypt card button
 * 4.4.11 - 12/30/16	- Completely revamped setup using OAuth
 *						- Added removal of pay method when 
 *							token is no longer reneable and notification
 *							via email.
 * 4.4.12 - 2/7/17	 	- Add full current_location for site (state param) in 
 *							Oauth request.
 *						- Fixed issue with single payment method in checkout
 *						- Removed form tags from orders.details view in admin
 *						- Adjusted scr14ipt verification to use only 
 *							name=payment_id rather than type=radio plus name
 *						- Unserialize params passed to mail for bad 
 *							token notify
 * 4.4.13 - 2/26/17		- Added renew check to is_root login.
 *						- Added additional notifications about expired tokens
 * 4.5.14 - 03/21/17	- Improved renewal methods
 *						- Added document.ready() to click function
 *							for order_submit button
 * 4.5.15 - 4/17/17		- Added trim to email address from order
 *						- Added detection of no form entry on checkout
 *						- Fixed issue with backend order_management
 * 4.6.16 - 8/6/17		- Fix class name in 'log' mode.
 *						- Added selection of config'd currencies in admin
 *						- Fixed issue with 'repay' not submitting
 * 4.6.17 - 9/2/17		- Fixed issue switching between tabs
 * 4.7.18 - 02/19/18	- Fixed issue with location no filter on configure tab
 * 						- Added more dynamic debugging
 *						= Added note to checkout to clarify postal code
 *						- Added use of API to update tokens
 * 4.8.19 - 9/10/18		- Added support for no change in status on void and refund.
 *						- Added domain name in expired token email subject
 *						- Removed billing_address from tx_data to cut down on Postal Code errors
 * 4.10.20 - 7/23/19    - Fixed typo for AuthOnly addon setting for status
 *                      - Fixed issue with refund not a number
 *                      - Modified refund to show when only partially refunded but not when 
 *                        fully refunded.
 *                      - Changes to support multiple refunds.  Fix to order status changes. Change to 
 *                        layout of capture/void/refunds to show which payment they apply to.
 *                      - Changes to split auth/capture amount across suborders in MVE or for supplier orders
 *						- Integration with RMA to automatically refund orders
 *						- RMA integration will refund taxes if EZ TaxJar is installed. (Will use fn_calculate_taxes() at a later date)
 *						- Compatibility with 4.10.3
 *						- Added new method for light processing
 *							- save cards with/without charging
 *							- returns data on customer card used, saved cards and transaction details
 *						- Added duplicate processing for saved card data.
 * 4.10.21 - 08/12/19	- Fixes to new single_pay() method.
 *						- Fixes for some variable names
 * 4.10.22 - 08/29/19	- Fixed formname that cs-cart changed in 4.10.3 (litechekout_payments_form -> litecheckout_payments_form).
 *						- Added hide of submit button until something is in the zipcode field of the payment form.
 * 4.10.23 - 09/09/19	- Fix to hiding submit button when user has saved cards.
 * 4.11.24 - 3/25/20    - Added bullet proofing for a reported case where there is NO error reported but not transaction data.
 * 4.11.25 - 4/6/20		- Found fixed the round-down by penny bug.  Seems to be a PHP bug but fixed by intval(strval($amount)).
 * 4.14.26.BETA - 07/21/22	- Added support for SCA (verifyBuyer()) for EU/UK and conversion to V2 API.
 * 4.15.27	- 12/4/22 	- Production release of SCA
 */
							
$addon_depends = '';
$addon_has_changelog = false;
/*
 * Use local.conf.php to turn these on/off
 */
//if( !defined('sq_sandbox_testing') )
//	define('sq_sandbox_testing', true);
//if( !defined('SQ_DBG') ) define('SQ_DBG', true);
?>