<?php

/*
 * Copyright 2016, 2017, 1st Source IT, LLC, EZ Merchant Solutions
 * All rights reserved.
 * Resale prohibited.
 */
if( !defined('BOOTSTRAP') ) die('Access denied');
use Tygh\Registry;

switch($action) {
	case 'construct':
		$payment_id = $dispatch_extra ? $dispatch_extra : sq_test_first_payment_id();
		$sqObj = new squarepay($payment_id);
		die("<pre>".print_r($sqObj,true) );
	case 'locations':
		$payment_id = $dispatch_extra ? $dispatch_extra : sq_test_first_payment_id();
		$sqObj = new squarepay($payment_id);
		$locations = $sqObj->get_locations();
		die("<pre>locations: ".print_r($locations,true));
	case 'location_names':
		$payment_id = $dispatch_extra ? $dispatch_extra : sq_test_first_payment_id();
		$names = sq_location_names($payment_id);
		if( !$names )
			$s = "No names found";
		else
			$s = implode("\n", $names);
		die("<pre>$s");
	case 'show_pp_params':
		$payment_id = $dispatch_extra ? $dispatch_extra : sq_test_first_payment_id();
		$sqObj = new squarepay($payment_id);
		$config_params = $sqObj->get_params();
		$processor_data = fn_get_processor_data($payment_id);
		if( !empty($processor_data['processor_params']['token_expires']) )
			$processor_data['processor_params']['token_expires'] 
					.= sprintf(" - (%s)", date("m/d/Y H:i:s", 
								$processor_data['processor_params']['token_expires'])
							  );
		die("<pre>processor params:".print_r($processor_data, true)."\nconfig params:".		print_r($config_params,true) );
	case 'payment_script':
		$order_info = array('payment_id' => 15);
		include(Registry::get('config.dir.addons') . "squarepay/payments/squarepay.php");
		die("Ok");
	case 'log':
		sq_log("Test message");
		fn_redirect("$controller.$mode.show_log");
	case 'show_log':
		echo '<pre>';
		die( "<pre>".file_get_contents(Registry::get('config.dir.addons')."squarepay/squarepay.log"));
	case 'clear_log':
		squarepay_log::clear_log();
		squarepay_log::add_msg("Cleared ".date("m/d/Y H:i:s") );
		fn_redirect("$controller.$mode.show_log");
	case 'show_order':
		$order_id = $dispatch_extra ? $dispatch_extra : (empty($_REQUEST['order_id']) ? 0 : $_REQUEST['order_id']);
		if( empty($order_id) )
			die("No order_id");
		$o_info = fn_get_order_info($order_id);
		die("<pre>$order_id:".print_r($o_info,true) );
	case 'get_customer':
		$user_id = $dispatch_extra;
		if( empty($user_id) )
			die("no user_id");
		$sqObj = new squarepay(sq_test_first_payment_id());
		$user_sq_data = $sqObj->get_user_sq_data($user_id);
		printf("<pre>user_sq_data:".print_r($user_sq_data,true) );
		if( empty($user_sq_data['id']) )
			die("No customer_id");
		$customer_id = $user_sq_data['id'];
		$customer_info = $sqObj->get_customer($customer_id);
		die("customer_info:".print_r($customer_info,true) );
	case 'list_transactions':
		$end_ts = TIME;
		if( !empty($dispatch_extra) ) {
			if( is_numeric($dispatch_extra) )
				$begin_ts = $dispatch_extra;
			else
				$begin_ts = strtotime($dispatch_extra);
		} else {
			$begin_ts = strtotime("midnight");
		}
		
		$sqObj = new squarepay(sq_test_first_payment_id());
		die("<pre>".print_r($sqObj->list_transactions($begin_ts, $end_ts), true) );
	case 'sq_pay_info':
		$order_id = $dispatch_extra;
		if( empty($order_id) ) 
			die("No order_id");
		$pay_data = sq_parse_payment_info($order_id);	
		$tx_data = sq_get_tx_data($order_id);
		die("<pre>pay_data:".print_r($pay_data,true).", tx_data:".print_r($tx_data,true) );
	case 'change_payment_action':
		$order_id = $_REQUEST['order_id'];
		$action = $dispatch_extra;
		if( empty($order_id)) {
			die("Missing &order_id=nnn");
		}
		if( empty($action)) {
			die("Missing action");
		}
		sq_change_payment_action($order_id, $action);
	case 'show_pay_info':
		$order_id = $order_id = $_REQUEST['order_id'];
		if( empty($order_id) ) 
			die("No order_id");
		die("<pre>payment_info:".print_r(sq_order_payment_info($order_id),true));
	case 'amounts':
		$amount = 123.2;
		echo "<pre>";
		printf("sq_currency_amount=%s\n", sq_amount_from_currency($amount));
		printf("negative sq_currency_amount=%s\n", sq_amount_from_currency($amount * -1));
		printf("sq_amount_currency=%s\n", sq_amount_to_currency($amount) );
		printf("negative sq_amount_currency=%s\n", sq_amount_to_currency($amount * -1) );
		die("Done amounts");
	case 'show_transactions':
		$order_id = empty($order_id) ? ( $dispatch_extra ? $dispatch_extra : 1845) : $order_id;
		$tx_info = sq_get_order_transactions($order_id);
		die( "<pre>".print_r($tx_info,true) );
	case 'show_extra_tx':
		$order_id = $dispatch_extra ? $dispatch_extra : 91779;
		$tx_data = sq_get_tx_data($order_id);
		printf("<pre>%d tx_extra: %s\n", $order_id, print_r($tx_data,true) );
		foreach($tx_data as $k => $tx) {
			$pay_info = sq_tx_to_pay($tx);
			printf("$k: %s", print_r($pay_info,true) );
		}
		exit;
	case 'remaining_tx':
		$order_id = $dispatch_extra ? $dispatch_extra : 91779;
		$o = fn_get_order_info($order_id);
		$transaction_id = empty($o['payment_info']['transaction_id'])
							? die("No transaction_id")
							: $o['payment_info']['transaction_id'];
		$data = sq_order_remaining_amount($order_id, $transaction_id);
		exit;
	case 'show_payments':
		echo "<pre>";
		foreach(sq_payment_ids() as $payment_id) {
			$data = fn_get_payment_method_data($payment_id);
			$data['processor_params']['token_expires'] = sq_time_to_date($data['processor_params']['token_expires']);
			print_r($data );
		}
		die("Done");
		
	case 'payment_tokens':
		$tokens = sq_payment_tokens();
		die("<pre>$action:".print_r($tokens,true) );
		
	case 'expire_now':
		foreach(sq_payment_ids() as $payment_id) {
			$p_data = fn_get_payment_method_data($payment_id);
			if( empty($p_data) )
				die("No payment data for payment_id=$payment_id");
			$now = sq_time_to_date(TIME);
			$pre_expire = sq_time_to_date($p_data['processor_params']['token_expires']);
			$p_data['processor_params']['token_expires'] = TIME - 1;
			fn_update_payment($p_data, $payment_id);
			$p_data = fn_get_payment_method_data($payment_id);
			$post_expire = sq_time_to_date($p_data['processor_params']['token_expires']);
sq_log("$controller.$mode.$action: token_expires set from $pre_expire to $post_expire");
//die("<pre>params:".print_r($p_data['processor_params'],true).", now=$now, pre_expire=$pre_expire, post_expire=$post_expire" );
		}
		$token = sq_valid_access_token($payment_id);
sq_log("$controller.$mode.$action: 1st sq_valid_access_token returns '$token'");
		sleep(2);
sq_log("$controller.$mode.$action: calling 2nd sq_valid_access_token");
		$token = sq_valid_access_token($payment_id);
sq_log("\tsq_valid_access_token returns '$token'");
		$log_buf = squarepay_log::$buf;
		die( "<pre>".print_r($log_buf,true));
		
	case 'oauth':
		$payment_id = $dispatch_extra ? $dispatch_extra : sq_test_first_payment_id();
		$payment_data = fn_get_payment_method_data($payment_id);
if( empty($payment_data) || empty($payment_data['processor_params']) )
die("Bad payment_id=$payment_id (".(empty($payment_data)?"payment_data":"processor_params").")" );
		$processor_params = array();
		$fields = array('sq_access_token', 'token_expires');
		foreach($fields as $field)
			unset($payment_data['processor_params'][$field]);
		fn_update_payment($payment_data, $payment_id);
		fn_redirect("payments.manage");
		die("Done");
		
	case 'current_user':
		die("Current user=".sq_current_user());
	case 'sq_api_credentials':
		die("Api credentials=".sq_api_credentials());
	case 'convert_tx':
		$order_id = $dispatch_extra ? $dispatch_extra : 0;
		$test_count = 20;
		$age = TIME -(SECONDS_IN_DAY * 60);		// 60 days old
		$count = 0;
		if( $order_id ) {
			die("<pre>".sq_convert_tx($order_id, true) );
		} else {
			$order_ids = db_get_fields("SELECT order_id FROM ?:orders WHERE timestamp > $age AND is_parent_order = 'N' AND parent_order_id != 0 ORDER BY order_id DESC");
			foreach($order_ids as $order_id) {
				sq_convert_tx($order_id, true);
				if( $count++ < $test_count)
					continue;
				die("Done $count orders");
			}
		}
		die( "Shouldn't get here");
	
	default: die("No such test '$action'");
}

function sq_test_first_payment_id() {
	$ids = sq_payment_ids();
	if( $ids )
		return current($ids);
	return 0;
}
?>