<?php
if( !defined('BOOTSTRAP') ) die("Access denied");

use Tygh\Registry;

if( file_exists($f=ez_fix_path(Registry::get('config.dir.addons')."ez_common/lib/upgrade.php")) ) {
	require_once($f);
} else {	// Need to force update of the tools
	require_once(ez_fix_path(Registry::get('config.dir.addons')."$controller/lib/upgrade/upgrade.php"));		// copy of common version of tools - used to bootstrap the ez_common addon
}

//sq_log("$controller.$mode: REQUEST:".print_r($_REQUEST,true) );

switch($mode) {
	case 'delete_card':
		$user_id = $_REQUEST['user_id'];
		$card_id = $_REQUEST['card_id'];
		$customer_id = $_REQUEST['customer_id'];
		$payment_id = $_REQUEST['payment_id'];
		// 10/4/16: Add protection against GET parameter abuse
		if( (empty($_SESSION['auth']['user_id']) || $_SESSION['auth']['user_id'] != $user_id)  ) {
			sq_log("Attempt to delete card by wrong user!!");
			fn_set_notification("E", __("error"), "You are not logged in or are the wrong user.", 'K');
			fn_redirect("checkout.checkout");
		}
		
		if(empty($user_id) || empty($card_id) || empty($customer_id) || empty($payment_id)) {
			sq_log("Bad user/card_id/customer_id/payment_id (user_id=$user_id, card_id=$card_id, customer_id=$customer_id, payment_id=$payment_id)");
			return;
		}
		$sqObj = new squarepay($payment_id);
		$response = $sqObj->delete_customer_card($user_id, $customer_id, $card_id);
		// 10/4/16: Fixed bug where $this was used instead of $sqObj
		if( !$response || !$sqObj->get_error_detail($response) ) {
			fn_set_notification('N', __("notice"), __("sq_deleted_card"));
		} else {
			fn_set_notification('E', __("error"), $sqObj->get_error_detail($response), 'K');
		}
		fn_redirect("checkout.checkout");
	case 'set_token':
		$detail_log = Registry::get('addons.squarepay.debug') > logLog;
		// 3/18/17 - added support for notification (errors from remote auth server)
		$notification = empty($_REQUEST['notification']) ? '' : $_REQUEST['notification'];
		if( empty($_REQUEST['payment_id'])
		|| empty($_REQUEST['access_token'])
		|| empty($_REQUEST['expires']) 
		|| empty($_REQUEST['merchant_id'])
		|| empty($_REQUEST['application_id']) 
		|| $_REQUEST['application_id'] != SQ_APPLICATION_ID ) {
			$s = "$mode: Bad token data".($notification ? " ($notification)" : '');
			if( $detail_log )
				$s = sprintf("%s. REQUEST: %s", $s, print_r($_REQUEST,true));
			die(sq_log($s));
		}
		$payment_id = $_REQUEST['payment_id'];
		$data = array('sq_access_token' => urldecode($_REQUEST['access_token']),
					  'token_expires' => $_REQUEST['expires'],
					  'merchant_id' => $_REQUEST['merchant_id']
					  );
		$payment_data = fn_get_payment_method_data($payment_id);
		if( empty($payment_data) )
			die(sq_log("$mode: Bad payment_id '$payment_id'"));
		if( empty($payment_data['processor_params']) )
			$payment_data['processor_params'] = array();
		$payment_data['processor_params'] = array_merge($payment_data['processor_params'], $data);
//sq_log("$mode: Updated payment data:".print_r($payment_data,true) );
		fn_update_payment($payment_data, $payment_id);
		sq_log("$mode: New token '$_REQUEST[access_token]'");
		//10/7/17 - added
		die("$mode: processed request");
		
	case 'get_token':	// ajax request for token
		if( empty($_REQUEST['payment_id']) )
			die("Bad payment_id");
			
		$payment_id = $_REQUEST['payment_id'];
		echo sq_valid_access_token($payment_id);
		exit;
		
	case 'show_session':
		die("<pre>".print_r($_SESSION,true) );
		
	case 'version':
		$ez_common = 'ez_common';
		addon_init($ez_common);
		$ez_version = addon_current_version($ez_common);
		if( empty($ez_version) )
			$ez_version = "not installed or missconfigured";
		addon_init($controller);
		$version = addon_current_version($controller);
		$msg = PRODUCT_NAME.": ".PRODUCT_VERSION." ".PRODUCT_EDITION."<br/>EZ Common: $ez_version<br/>$controller: $version";
		fn_set_notification('N', "$controller.$mode", $msg, true);
		fn_redirect(Registry::get('config.customer_index'));
		break;
	
	case 'test':
	case 'tests':
		switch($action) {
			case 'show_sq_data':
				$user_id = $_SESSION['auth']['user_id'];
				die("<pre>".print_r(sq_get_user_sq_data($user_id),true) );
			default: die("No such test '$action'");
		}

	default:
		die("No such mode '$mode'");
}
?>