<?php

if (!defined('BOOTSTRAP')) { die('Access denied'); }
use Tygh\Registry;
use Tygh\Http;
use Tygh\Mailer;

define('SQ_TESTING', true);
define('SQ_TYPE', 'q');
define('SQ_APPLICATION_ID', 'sq0idp-VJkEPCuka7f9XKnFh0pnJg');
define('SQ_SB_APPLICATION_ID', 'sandbox-sq0idb-reXt2tL18TbvJ_j2yWZBBg');
define('SQ_SB_ACCESS_TOKEN', 'EAAAEJu6JWKOELL7uzAUMBfqdM799Jn8WOZINiAtK1w4hVe24iwrPSFzTA77BolD');
define('SQ_SB_LOCATION_ID', 'KSYH3MXDG92NF');

define('SQ_TIME_TO_RENEW', 1);
define('SQ_NO_RENEW_REQUIRED', 2);
define('SQ_RENEW_OK', 3);
define('SQ_RENEW_FAILED', 4);

define('SQ_AUTHORIZE_URL', sprintf("https://connect.squareup.com/oauth2/authorize?client_id=%s&session=false&scope=%s&state=%s",
								urlencode(SQ_APPLICATION_ID), 
								urlencode("MERCHANT_PROFILE_READ PAYMENTS_READ PAYMENTS_WRITE CUSTOMERS_READ CUSTOMERS_WRITE ITEMS_READ ITEMS_WRITE ORDERS_READ ORDERS_WRITE"),
// 1/15/16 - Updated to use full http location.
// Note that http/https are both supported but http will cause
// the Oauth server to use GET instead of PUT.
// 1/25/18 - Updated to get 'state' parameter dynamically.
	   							''//urlencode(Registry::get('config.current_location'))
								));
define("SQ_TOKEN_RENEW", 7 * SECONDS_IN_DAY);	// Initiate renewal when expire within 7 days
define("SQ_TOKEN_GRACE", 15 * SECONDS_IN_DAY);	// Allow renewal when expired and within 15 days
define('EZ_OAUTH_URL', 'https://auth.ez-ms.com');

// Do the first installation stuff
function squarepay_install_setup($params=array()) {
	if( function_exists('addon_install_setup') )
		addon_install_setup('squarepay');
	sq_install($params);
}

if( !function_exists('ez_fix_path') ) {
	function ez_fix_path($s) {
		if( DIRECTORY_SEPARATOR != '/' )
			$s = str_replace('/', DIRECTORY_SEPARATOR, $s);
		return $s;
	}
}

function sq_install_lang_vars($force=false) {
	include(dirname(__FILE__)."/lib/lang_vars.php");
	$cnt = 0;
	if( !empty($lang_vars) ) {
		$langs = db_get_fields("SELECT lang_code FROM ?:languages");
		if( empty($langs) )
			$langs = array('en');

		foreach($lang_vars as $var => $val) {
			if( $force || (!($cur = db_get_field("SELECT name FROM ?:language_values WHERE name=?s AND lang_code='en'", $var))) ) {
				$cnt++;
				foreach($langs as $lang) {
					$dat = array('lang_code' => $lang, 'name' => $var, 'value' => $val);
					db_query("REPLACE INTO ?:language_values ?e", $dat);
				}
			}
		}
	}
	if( $cnt ) {
		$msg = sprintf("Installed %d language variables into %d languages", $cnt, count($langs));
		fn_set_notification('N', __("notice"), $msg, 'K');
	}
}

function sq_api_credentials($user_id=null) {
	static $creds = array();
	
	if( empty($user_id) )
		$user_id = $_SESSION['auth']['user_id'];
	if( empty($user_id) )
		return $creds[$user_id] = false;
		
	if( isset($creds[$user_id]) )
		return $creds[$user_id];
		
	$sq_api_credentials = db_get_row("SELECT email, api_key FROM ?:users WHERE user_id=?i", $_SESSION['auth']['user_id']);
	if( !empty($sq_api_credentials['api_key']) )
			return $creds[$user_id] = sprintf("%s:%s", $sq_api_credentials['email'], $sq_api_credentials['api_key']);
	return $creds[$user_id] = false;
}

function sq_current_user($field='email') {
	static $user = array();
	$user_id = $_SESSION['auth']['user_id'];
	if( !isset($user[$user_id][$field]) ) {
		$user[$user_id][$field] = db_get_field("SELECT $field FROM ?:users WHERE user_id=?i", $user_id);	
	}
	return $user[$user_id][$field];
}

function sq_install($params=array()) {
	$verbose = !empty($params['verbose']);
	
	// Ensure sq_api_credentials are set before install completes.
	if( empty($_SESSION['auth']['sq_api_credentials']) ) {
		$sq_api_credentials = sq_api_credentials();
		if( $sq_api_credentials )
			$_SESSION['auth']['sq_api_credentials'] = $sq_api_credentials;
	}

	$u_columns = fn_get_table_fields('users');
	if( $verbose ) {
		echo "<pre>";
		print( sq_log("Checking sq_data column in ?:users table... "));
	}
	if( !in_array('sq_data', $u_columns) ) {
		db_query("ALTER TABLE ?:users ADD COLUMN sq_data text NOT NULL");
		if( $verbose ) print( sq_log("Added column sq_data to ?users table")."\n");
	} elseif( $verbose) print( sq_log("Okay")."\n");
	$processor = db_get_row("SELECT * FROM ?:payment_processors WHERE processor_script=?s", 'squarepay.php');
	if( $verbose ) print( sq_log("Checking ?:payment_processors... ".($processor ? "OK" : "Added processor info"))."\n");
	if( !$processor )
		db_query("INSERT INTO ?:payment_processors (
								`processor`, `processor_script`, 
								`processor_template`, 
								`admin_template`, `callback`, `type`, `addon`)
						VALUES ('Squarepay', 'squarepay.php', 
								'addons/squarepay/views/orders/components/payments/squarepay.tpl', 
								'squarepay.tpl', 'N', 'P', 'squarepay')"
					);
	if( $verbose ) print( sq_log("Changing 'type' column collation to utf_bin in ?:order_data")."\n");
	db_query("ALTER TABLE  ?:order_data CHANGE  `type`  `type` CHAR( 1 ) 
				CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT  ''");

	$force = false;
	foreach($params as $k => $v) {
		switch($k) {
			case 'install_templates':
				if( $v ) {
					$repo_dir = "var/themes_repository/responsive/templates/addons/squarepay";
					if( $verbose ) print( sq_log("Installing templates from $repo_dir")."\n");
					foreach(glob("design/themes/*", GLOB_ONLYDIR) as $dir) {
//						if( is_dir("$dir/templates/addons/squarepay") ) {
//							if( $dir == 'design/themes/responsive') {
								if($verbose) print( sq_log("\t$dir/templates/addons/squarepay")."\n");
								fn_copy($repo_dir, "$dir/templates/addons/squarepay");								
//							} else {
//								fn_rm("$dir/templates/addons/squarepay");	// Remove from installed themes other than responsive
//								if($verbose) print( sq_log("\tRemoved $dir/templates/addons/squarepay")."\n");
//							}
//						}
					}
				}
				break;
			case 'force':
				$force = $v;
				break;
		}
	}
	sq_install_lang_vars($force);

	// Convert last 50 days of payment transactions.
	if( !($converted = file_exists($f = Registry::get("config.dir.addons")."/squarepay/upgrade/.tx_converted")) ) {
		$age = TIME -(SECONDS_IN_DAY * 60);		// 60 days old
		$count = 0;
		$order_ids = db_get_fields("SELECT order_id FROM ?:orders WHERE timestamp > $age AND is_parent_order = 'N' AND parent_order_id != 0 ORDER BY order_id DESC");
		foreach($order_ids as $order_id) {
			$count += sq_convert_tx($order_id);
		}
		fn_set_notification("N", __("notice"), "Converted $count orders to new transaction format.");
		file_put_contents($f, date("m/d/Y"));
	}
	if( $converted && $verbose)
		print("Skppped transaction conversion.  Already converted on ".file_get_contents($f)."\n");
	elseif($verbose && $count)
		print("Converted $count orders to new transaction format.\n");
	
	// Clear all the caches
	fn_clear_cache();
	fn_clear_template_cache();
//	if( $verbose ) die( sq_log("Clear caches... Done"));
}

function sq_get_user_sq_data($user_id) {
	$sq = db_get_field("SELECT sq_data FROM ?:users WHERE user_id=?i", $user_id);
	// For testing card strings with bogus data
	if( defined('sq_card_testing') && sq_card_testing )
		$sq = serialize(['id'=>'test_cust1', 'cards' => sq_test_cards()]);
	if( $sq )
		return unserialize($sq);
	return $sq;
}


function sq_put_user_sq_data($user_id, $sq) {
	$sq = sq_de_dup_sq_data($sq);
	if( $sq && $user_id) {
		db_query("UPDATE ?:users SET sq_data=?s WHERE user_id=?i", serialize($sq), $user_id );
	}
}

function sq_order_status_menu($extra=array()) {
	$menu = array();
	if( $extra )
		$menu = $extra;
	$menu = array_merge($menu, fn_get_simple_statuses(STATUSES_ORDER));
	return $menu;
}
	
function sq_get_payment_info($order_id) {
	$data = db_get_field("SELECT data FROM ?:order_data WHERE type='P' AND order_id=?i", $order_id);
	return $data ? unserialize(fn_decrypt_text($data)) : array();
}
	
function sq_put_payment_info($order_id, $data) {
	$_data = array('order_id' => $order_id, 'type'=>'P', 'data'=>fn_encrypt_text(serialize($data)) );
	db_query("REPLACE INTO ?:order_data ?e", $_data);
}

function sq_is_square_order_payment($order_id) {
	static $cache = array();
	if( isset($cache[$order_id]) ) {
		return $cache[$order_id];
	}
	$payment_id = db_get_field("SELECT payment_id FROM ?:orders WHERE order_id=?i", $order_id);
	$script = '';
	return $cache[$order_id] = sq_is_square_payment($payment_id);
}

function sq_is_square_payment($payment_id) {
	$script = db_get_field("SELECT template FROM ?:payments WHERE payment_id=?i", (integer)$payment_id);
	return strpos($script, 'squarepay') !== false;
}

function sq_is_square_order(&$order_info) {
	// 7/29/17: Fix for failed payment (won't have payment_id)
	return !empty($order_info['payment_id']) && db_get_field("SELECT payment_id FROM ?:payments WHERE payment_id=?d AND template LIKE '%squarepay%'", $order_info['payment_id']);
}

function sq_clean_payment_info($order_id, $fields=array() ) {
	if( !sq_is_square_order($order_id) )
		return;
		
	$has_children = (array)db_get_fields("SELECT order_id FROM ?:orders WHERE parent_order_id=?i", $order_id);
	
	$dflt_fields = array('sq_nonce', 'sq_customer_id', 'sq_card_id', 'verification_token', 
						 'sq_expire_month', 'sq_expire_year', 
						 'sq_postal_code', 'sq_expiration_date', 
						 'sq_save_card'
						 );
	$fields = array_merge($fields, $dflt_fields);
	
	foreach(array_merge(array($order_id), $has_children) as $order_id) {
		$p_info = sq_get_payment_info($order_id);
		foreach($fields as $field) {
			if( isset($p_info[$field]) )
				unset($p_info[$field]);
		}
		sq_put_payment_info($order_id, $p_info);
	}
}

function sq_order_payment_id($order_id) {
	return db_get_field("SELECT payment_id FROM ?:orders WHERE order_id=?i", $order_id);
}

function sq_test_cards() {
	return [
			'test_card1' => 
				['card_brand'=>'tst_brand1', 'cardholder_name'=>'test name', 'last_4'=>'1234', 'exp_month'=>'10', 'exp_year'=>'2022'],
				['card_brand'=>'tst_brand1', 'cardholder_name'=>'test name', 'last_4'=>'5678', 'exp_month'=>'11', 'exp_year'=>'2022']
			];
}

function sq_checkout_cards($user_id, $payment_id, $add_delete_link=true) {
	if(!$user_id)
		return array();
	$sq_data = sq_get_user_sq_data($user_id);
//die("<pre>sq_data:".print_r($sq_data,true) );
	if( empty($sq_data['cards']) )
		return array();
	$customer_id = $sq_data['id'];
	$cards = array();
	foreach($sq_data['cards'] as $card_id => $c_data) {
		$cards[$card_id] = sprintf("%s - %s - ***%s - %s/%s %s", 
										$c_data['card_brand'],
										$c_data['cardholder_name'],
										$c_data['last_4'],
										$c_data['exp_month'],
										$c_data['exp_year'],
										$add_delete_link
										? "<a href=\"?dispatch=squarepay.delete_card&amp;payment_id=$payment_id&amp;user_id=$user_id&amp;card_id=$card_id&amp;customer_id=$customer_id".(!empty($_REQUEST['order_id'])?"&amp;order_id=$_REQUEST[order_id]":'').'">'.__("delete")."</a>"
												: ''
							);
	}
	return $cards;
}

function sq_get_tx_data($order_id) {
//	static $cache = array();
//	if( isset($cache[$order_id]) )
//		return $cache[$order_id];
	$d = db_get_field("SELECT data FROM ?:order_data WHERE type=?s AND order_id=?i", SQ_TYPE, $order_id);
	return $cache[$order_id] = $d 
								? (($v = unserialize($d)) 
									? $v 
									: array()) 
								: array();
}

function sq_get_order_transactions($order_id) {
	$transactions = sq_get_tx_data($order_id);	// get tx_data;
	$payment_info = sq_order_payment_info($order_id);
	$result = array();
	if( empty($payment_info['transaction_id'])) {
		return array();
	}
	if( $payment_info ) {
		$idx = $payment_info['transaction_id'];
		$payment_info_tx = sq_pay_to_tx($payment_info);	// Convert to tx style
		$result[$idx][$idx] = $payment_info_tx;
	}
	foreach($transactions as $parent_transaction_id =>  $_tx_info) {
		if( empty($_tx_info)) {
			continue;
		}
		// This assumes we have repaired all the old transactions
		foreach($_tx_info as $transaction_id => $tx_info) {
			// We have parent_transaction_id already
			// Fix old data
			$tx_info['amount'] = str_replace('$', '', $tx_info['amount']);
			$result[$parent_transaction_id][$transaction_id] = $tx_info;
		}
	}
	return $result;
}

function sq_order_payment_info($order_id) {
	static $cache = array();
	if( isset($cache[$order_id]) ) {
		return $cache[$order_id];
	}
	
	$payment_info = db_get_field("SELECT data FROM ?:order_data WHERE type='P' AND order_id=?i",
			$order_id);
	$cache[$order_id] = array();
	if($payment_info) {
        $payment_info = unserialize(fn_decrypt_text($payment_info));
        $cache[$order_id] = $payment_info;
	}
	return $cache[$order_id];
}

function sq_put_tx_data($order_id, $data) {
	$d = array('order_id'=>$order_id,
			   'type'=>SQ_TYPE,
			   'data'=>serialize($data)
			   );
	db_query("REPLACE INTO ?:order_data ?e", $d);
	return $data;
}

function sq_parse_payment_info($order_id) {
	$raw = sq_get_payment_info($order_id);
	return sq_pay_to_tx($raw);
}
	
function sq_pay_to_tx_data($tx_data) {
	$result = array();
	foreach($tx_data as $k => $tx) {
		$result[] = sq_pay_to_tx($tx);
	}
	return $result;
}
function sq_pay_to_tx($raw) {
	if( empty($raw) )
		return array();
		
	$actions = array('AUTHORIZED', 'CAPTURED', 'VOIDED', 'REFUNDED');
	$cards = array('MASTERCARD', 'VISA', 'AMERICAN_EXPRESS', 
				   'DISCOVER', 'DISCOVER_DINERS', 'JCB', 'CHINA_UNIONPAY');
	$parsed = array();
	foreach($raw as $k => $v) {
		switch($k) {
			case 'payment_id':
				$parsed['transaction_id'] = $v;
				break;
			case 'tender_id':
			case 'transaction_id':
			case 'text_response':
			case 'order_status':
			case 'balance':
				$parsed[$k] = $v;
				break;
			case 'verification_token':
			case 'source_id':
				break;	// ignore
			default:
				if( in_array($k, $cards) ) {
					$parsed['card_brand'] = $k;
					$parsed['last_4'] = $v;
				} elseif( in_array($k, $actions) ) {
					$parsed['action'] = $k;
					$parsed['amount'] = sq_amount_from_currency($v);
				} // no unknowns
				/* else {
					$parsed[$k] = $v;
				}*/
				break;
		}
	}					
//die("<pre>raw:".print_r($raw,true).", parsed:".print_r($parsed,true).", new_raw:".print_r($new_raw,true) );
	return $parsed;
}

function sq_tx_data_to_pay($tx_data) {
	$result = array();
	foreach($tx_data as $k => $tx) {
		$result = sq_tx_to_pay($tx);
	}
	return $result;
}
function sq_tx_to_pay($ar) {
	if( empty($ar) )
		return array();
		
	$pay_info = array();
	foreach($ar as $k => $v) {
		switch($k) {
			case 'card_brand':
				$pay_info[$ar['card_brand']] = empty($ar['last_4']) ? '' : $ar['last_4'];
				break;
			case 'action':
				$pay_info[$ar['action']] = empty($ar['amount']) 
											? '' 
											: $ar['amount'];
				break;
			case 'transaction_id':
				$pay_info['transaction_id'] = $v;
				break;
//			case 'tender_id':
//				$pay_info['tender_id'] = $v;
//				break;
			case 'text_response':
				$pay_info['text_response'] = $v;
				break;
			case 'order_status':
				$pay_info['order_status'] = $v;
				break;
			case 'last_4':
			case 'amount':
				break;
			default:
				break;	// no unknowns
				$pay_info[$k] = $v;
				break;
		}
	}
	return $pay_info;
}

function sq_amount_from_currency($amount, $currency=CART_SECONDARY_CURRENCY) {
	$cur_data = Registry::get("currencies.$currency");
	$symbol = $cur_data['symbol'];
	$v = str_replace($symbol, '', $amount);
	return fn_format_price($v);
}
function sq_amount_to_currency($amount, $currency=CART_SECONDARY_CURRENCY) {
	$amount = sq_amount_from_currency($amount);	// Force to amount fist
	$cur_data = Registry::get("currencies.$currency");
	$result = sprintf("%s%.02f", $cur_data['symbol'], $amount);
	return $result;
}

// 2/4/22 - add currency
function sq_tx_amount($_amount, $currency=CART_SECONDAY_CURRENCY) {
	/* 2/3/22 - Honor decimals
	$amount = sq_amount_from_currency($_amount, $currency);
	$amount *= 100;	// Get rid of cents
	*/
	
	// Take currency decimals into account.
	$cur_data = Registry::get("currencies.$currency");
	$factor = pow(10, $cur_data['decimals']);
	$amount = ($factor ? ($_amount * $factor) : $_amount);
	// 4/6/20 - Add strval() given intval will sometimes round down by a penny.  Seems to be a PHP bug.
	$amount = intval(strval($amount));	// get rid of any decimals
	return $amount;
}

/*
 * Finds the transaction chain that 
 * matches the pareent_transaction_id and where 
 * one of the transactions has a matchin action
 * Returns the branch and the leaf
 */
function sq_find_extra_tx($order_id, $parent_transaction_id, $action) {
	$amount = 0;
	$new_tx = array();
	$tx_data = sq_get_order_transactions($order_id);	// Get structured tx info
	
	$payment_info = sq_get_payment_info($order_id);
	$pay_tx = sq_pay_to_tx($payment_info);
	// Current payment overwrites top of tx_tree
	$tx_data[$parent_transaction_id][$parent_transaction_id] = $pay_tx;
	// Nothing
	if( empty($tx_data[$parent_transaction_id]) ) {
		return array([],[]);
	}
	foreach($tx_data[$parent_transaction_id] as $leaf_transaction_id => $tx_info) {
		if( $tx_info['action'] == $action )
		//	return array($tx_data[$parent_transaction_id], $tx_info);
			return array($tx_data, $tx_info);
	}
	return array([],[]);
}

function sq_order_remaining_amount($order_id, $parent_transaction_id) {
	$tx_data = sq_get_order_transactions($order_id);
	if( empty($tx_data[$parent_transaction_id]) ) {
		// No matching transaction
		return 0;
	}
	$remaining_amount = $tx_data[$parent_transaction_id][$parent_transaction_id]['amount'];
	foreach($tx_data[$parent_transaction_id] as $k => $tx_info) {
		if( $tx_info['action'] == 'REFUNDED') {
			$val = floatval(str_replace('$', '', $tx_info['amount']));
//sq_log(__FUNCTION__.": tx_info[amountt]={$tx_info['amount']}, val=$val");
			$remaining_amount += $val;
		}
	}
	return $remaining_amount;
	
	/* Old method
	$order_total = db_get_field("SELECT total FROM ?:orders WHERE order_id=?i", $order_id);
	$tx_data = sq_get_tx_data($order_id);
	$remaining_amount = floatval($order_total);
	foreach($tx_data as $tx) {
		if( $tx['action'] == 'REFUNDED' ) {
			$remaining_amount += floatval(str_replace('$','', $tx['amount']));
		}
	}
	return $remaining_amount;
	*/
}

function sq_update_tx_data($order_id, $transaction_id, $data) {
	$tx_data = sq_get_order_transactions($order_id);	// Get all
	$hit = false;
	foreach($tx_data as $parent_tx_id => $_info) {
		foreach($_info as $k => $tx_item) {
			if( $tx_item['transaction_id'] == $transaction_id ) {
				$tx_data[$parent_tx_id][$k] = array_merge($tx_item, $tx);
				$hit = true;
				break 2;
			}
		}
	}
	if( !$hit ) {
		$tx_data[$transaction_id][] = $tx;
	}
	if( $tx_extra )
		sq_put_tx_data($order_id, $tx_data);
}

function sq_change_payment_action($order_id, $action, $status_to='') {
	// Get all the siblings of this order if $action == CAPTURED or VOIDED
	$order_ids[] = $order_id;
	if( $action == 'CAPTURED' || $action == 'VOIDED') {
		$parent_id = db_get_field("SELECT parent_order_id FROM ?:orders WHERE order_id=?i", $order_id);
		if( $parent_id ) {
			$order_ids = db_get_fields("SELECT order_id FROM ?:orders WHERE parent_order_id=?i", $parent_id);
		}
	}
	
	// Loop through all the orders
	$processed_orders = 0;
	foreach($order_ids as $order_id) {
		$payment_info = sq_get_payment_info($order_id);
		foreach($payment_info as $k => $v) {
			if( in_array($k, array('AUTHORIZED','CAPTURED','VOIDED')) ) {
				$processed_orders++;
				unset($payment_info[$k]);
				$payment_info[$action] = $v;
				sq_put_payment_info($order_id, $payment_info);
				if( $status_to ) {
					fn_change_order_status($order_id, $status_to);
					sq_log(__METHOD__.": Order status ($order_id) changed to '$status_to'", logDetail);
				}
				break;
			}	// if in_array
		}	// foreach payment_info
	}	// foreach order_id
	return $processed_orders;
}
	


function sq_location_names($payment_id) {
	$sqObj = new squarepay($payment_id);
	if( $sqObj === null ) {
		if( AREA == 'A' )
			fn_set_notification('E', __("error"), __("sq_bad_access_token"), 'K');
		else
			fn_set_notification('E', __("error"), __("sq_client_bad_access_token"), 'K');
		return array();
	}
//sq_log(__FUNCTION__.": sqObj:".print_r($sqObj,true) );
	return $sqObj->get_location_names();
}

function sq_state_param($payment_id) {
	$state = urlencode(sprintf("%s-%d", Registry::get('config.current_location'), $payment_id));
													  
	// If no api credentials, use the old method
	if( empty($_SESSION['auth']['sq_api_credentials']) ) 
		return $state;
	
	return urlencode(http_build_query(array('site' => Registry::get('config.current_location'),
								  'payment_id' => $payment_id,
								  'api_credentials' => $_SESSION['auth']['sq_api_credentials']
								  ))
							);
}

function sq_renew($expires) {
	if( !$expires )	{ // Not set or non-existent
		return SQ_RENEW_FAILED;
	}
							
	return (TIME > ($expires + SQ_TOKEN_GRACE) 
			? SQ_RENEW_FAILED		// Can't renew
			: (TIME > ($expires - SQ_TOKEN_RENEW)
				? SQ_TIME_TO_RENEW	// time to renew
				: SQ_NO_RENEW_REQUIRED	// Not yet
				)
			);
}

function sq_time_to_date($ts) {
	return date("m/d/Y H:i:s", $ts);
}

// 1/27/18: Added $log to parameters to supress interval timer No token messages
function sq_valid_access_token($payment_id, $log=true) {
	if( sq_test_site() ) {
		return SQ_SB_ACCESS_TOKEN;
	}
		
	// Get current payment info
	$payment_data = fn_get_payment_method_data($payment_id);
	if( empty($payment_data['processor_params']['sq_access_token']) && !sq_test_site() ) {
		if( $log )
			sq_log(__FUNCTION__.": No access_token in payment data", logDetail);
		return false;
	}
		
	// 9/29/17: Add bulletproofing
	$access_token = empty($payment_data['processor_params']['sq_access_token']) 
						? ''
						: $payment_data['processor_params']['sq_access_token'];
	if( sq_test_site() ) {
		return $access_token ? $access_token : SQ_SB_ACCESS_TOKEN;
	}
		
	$expires = empty($payment_data['processor_params']['token_expires']) ? 0 : $payment_data['processor_params']['token_expires'];
	if( !$expires )	{	// Sandbox handled above.  No token_expires probably means an old site
		sq_log(__FUNCTION__.": Expires is empty, returning false", logDetail);
		return false;	// this should switch us over.
	}
	$renew = sq_renew($expires);
	
	switch($renew) {
		case SQ_RENEW_FAILED:	// Can't renew
			sq_log(__FUNCTION__.": Renew failed.  Unsetting sq_aqccess_token, merchant_id, token_expires");
			unset(	$payment_data['processor_params']['sq_access_token'],
					$payment_data['processor_params']['merchant_id'],
					$payment_data['processor_params']['token_expires']
				);
			fn_update_payment($payment_data, $payment_id);
			sq_log(__FUNCTION__.": Token expired or doesn't exist (".date('m/d/Y H:i:s', $expires + SQ_TOKEN_GRACE)."), older than ".date('m/d/Y H:i:s', $expires).", can't renew!" );
			sq_notify_no_access_token($payment_data);
			return false;
			
		case SQ_RENEW_OK:	// Not ready to renew
		case SQ_NO_RENEW_REQUIRED:
			return $payment_data['processor_params']['sq_access_token'];
			
		case SQ_TIME_TO_RENEW:	// Time to renew
			sq_log(__FUNCTION__.": Attempting to renew '$payment_data[payment]'");
			// Expired but within renewal time
			//		request renewal
			$url = sprintf("%s?dispatch=square.renew", EZ_OAUTH_URL);
			$json_response = Http::get($url, array('access_token'=>$access_token) );
			// Empty means couldn't renew
			//		zap existing payment info
			if( empty($json_response) ) {
				sq_log("\tRenewal failed, json_response=$json_response");
				unset(	$payment_data['processor_params']['sq_access_token'],
						$payment_data['processor_params']['merchant_id'],
						$payment_data['processor_params']['token_expires']
					);
				fn_update_payment($payment_data, $payment_id);
				return false;
			}
			// Got a response
			$response = json_decode($json_response, true);
			if( $response ) {
				$response['token_expires'] = strtotime($ex_date = $response['expires_at']);	// set new expires
				$response['sq_access_token'] = $response['access_token'];
				unset($response['token_type'], 
					$response['expires_at'], 
					$response['access_token'] );	// zap unnecessary info
				$payment_data['processor_params'] = array_merge($payment_data['processor_params'], $response);
				fn_update_payment($payment_data, $payment_id);
				sq_log("\tNew expiration date for $payment_data[payment] is $ex_date");
				return $payment_data['processor_params']['sq_access_token'];
			} else {
				sq_log(__FUNCTION__.": Renew: bad response:".print_r($response,true) );
			}
			return false;
	}	// switch
	return false;	// shouldn't get here either
}

function sq_debugging() {
	return defined('SQ_DBG') && SQ_DBG;
}

function sq_testing() {
//	return SQ_TESTING || sq_test_site();
	return sq_test_site();
}

function sq_test_site() {
	return defined('sq_sandbox_testing') && sq_sandbox_testing;
}

function sq_company_id() {
	return Registry::get('runtime.forced_company_id') 
			? Registry::get('runtime.forced_company_id')
			: Registry::get('runtime.company_id');
}

function sq_notify_no_access_token($payment_info) {
	Mailer::sendMail( array(
		'to' => 'company_orders_department',
		'from' => 'company_orders_department',
		'reply-to' => 'company_orders_department',
		'data' => array('payment_info' => $payment_info
						),
		'tpl' => 'addons/squarepay/expired_access_code.tpl',
		'company_id' => fn_allowed_for('MULTIVENDOR') ? 0 : sq_company_id()
		), 'A', CART_LANGUAGE);
}

function sq_payment_ids() {
	$processor_id = db_get_field("SELECT processor_id FROM ?:payment_processors WHERE processor_script='squarepay.php'");
	return db_get_fields("SELECT payment_id FROM ?:payments WHERE processor_id=?i AND status='A'", $processor_id);
}

function sq_payment_tokens() {
	$payment_ids = sq_payment_ids();
	
	$token_data = [];
	foreach($payment_ids as $payment_id) {
		$x = sq_payment_token($payment_id);
		if( $x ) $token_data[$payment_id] = $x;
	}
	return $token_data;
}

function sq_payment_token($payment_id) {
	$token = [];
	$params = db_get_field("SELECT processor_params FROM ?:payments WHERE payment_id=?i", $payment_id);
	if( $params ) {
		$params = unserialize($params);
		$token = $params;								 
	}
	return $token;
}

function sq_update_payment_token($payment_id, $data) {
	$data = serialize($data);
	return db_query("UPDATE ?:payments SET processor_params=?s WHERE payment_id=?i", $data, $payment_id);
}

function sq_add_round_down($v1, $v2, $precision=2) {
	$val = (floor($v1 * 100) + floor($v2 * 100)) / 100;
	return round($val, $precision, PHP_ROUND_HALF_DOWN);
}

function sq_backtrace($start_level=1) {
	$ar = debug_backtrace();
	$out = array();
	for($i=$start_level; isset($ar[$i]); $i++) {
		$out[] = sprintf("%s: (line %d) %s()", 
										   empty($ar[$i]['file']) ? "file not set" : $ar[$i]['file'],
										   empty($ar[$i]['line']) ? "line not set" : $ar[$i]['line'], 
										   empty($ar[$i]['function']) ? "function not set" : $ar[$i]['function']);
	}
	return implode("\n", $out);
}

function sq_order_actions() {
	return array('AUTHORIZED', 'CAPTURED', 'REFUNDED', 'VOIDED');
}

function sq_convert_tx($order_id, $verbose=false) {
	static $sq_payment_ids = array();
	if( empty($sq_payment_ids) ) {
		$sq_payment_ids = sq_payment_ids();
	}
	
	if( fn_allowed_for("MULTIVENDOR"))
		$no_parent_condition = "AND is_parent_order = 'N' AND parent_order_id != 0";
	else
		$no_parent_condition = "";
		
	$order_payment_id = db_get_field($q="SELECT payment_id FROM ?:orders WHERE order_id=?i $no_parent_condition", $order_id);
	if( !in_array($order_payment_id, $sq_payment_ids) ) {
//sq_dbg("order_id=$order_id is NOT a square payment (order_payment_id=$order_payment_id)", true);
		return false;
	}
//sq_dbg("order_id=$order_id IS a square payment (order_payment_id=$order_payment_id)", true);
	
	$pay_info = sq_get_payment_info($order_id);
	$tx_data = sq_get_tx_data($order_id);	
	
	$transaction_id = empty($pay_info['transaction_id'])
						? 0	// This should probably be an error.
						:$pay_info['transaction_id'];

	$pay_tx = sq_pay_to_tx($pay_info);
	// Add in the newer extra fields
	$pay_tx['timestamp'] = TIME;
	$pay_tx['parent_transaction_id'] = $transaction_id;
	$pay_tx['balance'] = $pay_tx['amount'];
	$prev = isset($tx_data[$transaction_id][$transaction_id]) 
				? $tx_data[$transaction_id][$transaction_id]
				: array();
	if( $prev )	// If previously done or newer conversion.
		return 0;
	$pay_tx = array_merge($prev, $pay_tx);	// merge any existing with new
	$tx_data[$transaction_id][$transaction_id] = $pay_tx;
	$tx_data = array_reverse($tx_data);		// Get this one first
	sq_put_tx_data($order_id, $tx_data);	// Save it
if( $verbose) sq_dbg(sprintf("\t %s $order_id:%s", $prev ? "Updaated" : "Created", 
						print_r($tx_data,true)), true);
	return true;
}

function sq_de_dup_sq_data($sq_data) {
	$dups = array();
	if( empty($sq_data['cards'])) 
		return array();
		
	foreach($sq_data['cards'] as $cid => $c_info) {
		$dups[$c_info['last_4']][$cid] = $c_info;
	}
	foreach($dups as $last_4 => $dup_data) {
		$exp_val = 0;
		// Multople instances of this card (last 4).
		foreach($dup_data as $cid => $v) {
			if( empty($cid)) {	// no card cid in array - bad data
				unset($sq_data['cards'][$cid]);
				unset($dup_data[$last_4][$cid]);
				continue;
			}
			if( $exp_val >= (integer)$v['exp_year'].$v['exp_month'] ) {	// dup found, delete it
				unset($sq_data['cards'][$cid]);
				unset($dup_data[$last_4][$cid]);
			} else {
				$exp_val = (integer)$v['exp_year'].$v['exp_month'];
			}
		}
	}
	return $sq_data;
}


function sq_item_tax($quantity, $order_id, $cart_id, $item) {
	$item_tax = 0;
	$item['amount'] = $quantity;
	$order_info = fn_get_order_info($order_id);
	// Reset to be this item only for refund.
	$order_info['products'][$cart_id] = $item;
	$item_tax = eztj_tax_for_order($order_info, array($cart_id => $item));
/*
sq_log(sprintf("%s: item_tax[amount_to_collect]=%.2f,  quantity=%d, item[price]=%.2f, item[amount]=%d, order_id=%s", 
	__FUNCTION__, 
	$item_tax['amount_to_collect'], $quantity, 
	$item['price'], $item['amount'], $order_id)
);
*/
	return empty($item_tax['amount_to_collect']) ? 0 : $item_tax['amount_to_collect'];;
}

function sq_cart_verification_fields() {
	$fields = ['firstname', 'lastname', 'address', 'address_2', 'email', 'country', 'phone', 'state', 'city'];
	$prefixes = ["", "b_", "s_"];
	$cart = empty($_SESSION['cart']) ? [] : (empty($_SESSION['cart']['user_data']) ? $_SESSION['cart'] : $_SESSION['cart']['user_data']);
	$cart_verification_fields = [];
	foreach($prefixes as $prefix) {
		foreach($fields as $field) {
			$cart_verification_fields[$prefix.$field] = empty($cart[$prefix.$field]) ? '' : $cart[$prefix.$field];
		}
	}
	return $cart_verification_fields;
}

// Hooks
function fn_squarepay_get_payments_post(&$params, &$payments) {
	if( AREA == 'C' ) {
		foreach($payments as $payment_id => $p_info) {
			if( !empty($p_info['processor_params']) 
			&& !empty($p_info['template']) 
			&& strpos($p_info['template'], 'squarepay') ) {
				// 2/6/17: Added unserialized assingment to p_info[processor_params] as well
				$p_info['processor_params'] = 
					$params = unserialize($p_info['processor_params']);
				$valid_token = sq_valid_access_token($payment_id) && !empty($params['sq_application_id']);
				if( !$valid_token ) {	// Couldn't renew
					unset($payments[$payment_id]);
					sq_notify_no_access_token($p_info);
					sq_log("No current access token or application_id for payment method '$p_info[payment]'");
				}
			}
		}
	}
}
	
function fn_squarepay_fill_auth(&$auth, &$user_data, $area, &$prior_auth) {
	// Admin area and logging in (user_id set no prior_auth[user_id]
	if( $area == 'A' && !empty($auth['user_id']) && empty($prior_auth['user_id']) ) { // is an admin login
	
		// If API is enabled for this user, set the credentials
		$sq_api_credentials = db_get_row("SELECT email, api_key FROM ?:users WHERE user_id=?i", $auth['user_id']);
		if( $sq_api_credentials['api_key'] )
			$auth['sq_api_credentials'] = sprintf("%s:%s", $sq_api_credentials['email'], $sq_api_credentials['api_key']);
			
		// If no is_root not set OR this is a root admin
		if( empty($auth['is_root']) || $auth['is_root'] == 'Y' ) {
			// Check each payment_id
			foreach(sq_payment_ids() as $payment_id) {
				$payment_data = fn_get_payment_method_data($payment_id);
				// Active and token_not set or expired
				if( $payment_data['status'] == 'A' 
				&& (empty($payment_data['processor_params']['token_expires'])
					|| $payment_data['processor_params']['token_expires'] < TIME) ) {
					$token = sq_valid_access_token($payment_id);		// Will renew if needed
					// Let the renewal checks run
					if( empty($token) ) {	// Can't renew for some reason
						$p_info = fn_get_payment_method_data($payment_id);
						$expire_date = empty($p_info['processor_params']['token_expires'])
										? "Not set"
										: sq_time_to_date($p_info['processor_params']['token_expires']);
						sq_log(__FUNCTION__.": Bad access token, notifying admin.  Token expired $expire_date");
						// send email to admin
						sq_notify_no_access_token($p_info);
					}	// if token
				}	// if payment_data[status]
			}	// foreach
		}	// is root
	}	// area == A
}


// Used to split payment info across child orders
// Seems to only be called once per parent order
function fn_squarepay_order_placement_routines($order_id, $notification, &$order_info, &$_error) {
	if( $order_info['is_parent_order'] != 'Y')	// Only deal with parent orders
		return;
		
	$parent_payment_info = $order_info['payment_info'];
	$parent_transaction_id = $order_info['payment_info']['transaction_id'];
	// Get the children of this order
	$child_order_data = db_get_hash_array("SELECT order_id, total FROM ?:orders where is_parent_order='N' && parent_order_id=?i", 'order_id', $order_id);
	
	$parent_tx = sq_get_order_transactions($order_id);	// parent order_transactions
	foreach($child_order_data as $oid => $o_info) {
		$pay_info = sq_get_payment_info($oid);	// child payment info
		$found_action = '';
		foreach(sq_order_actions() as $action ) {
			if( isset($pay_info[$action]) ) {
				$found_action = $action;	// Probaly always either CAPTURED or AUTHORIZED
				break;
			}
		}
		if( $found_action ) {	// Got a hit
			$pay_info[$found_action] = $child_order_data[$oid]['total'];	// Reset the amount of this order to actual total
			sq_put_payment_info($oid, $pay_info);	// Save it
		}
		$transactions = sq_get_order_transactions($oid);	// Get the transactions for this order
		if( isset($transactions[$parent_transaction_id][$parent_transaction_id])) {		// If it's set, adjust it.
			$transactions[$parent_transaction_id][$parent_transaction_id]['amount'] = 
				$transactions[$parent_transaction_id][$parent_transaction_id]['balance'] = $child_order_data[$oid]['total'];
			sq_put_tx_data($oid, $transactions);	// Adn save it.
		}
	}
}


/*
 * Integrate with RMA addon for refunds
 *
 * Note: none of the parameters are by reference so no modifications can
 * be made to the calling RMA subsystem.
 *
 */
function fn_squarepay_rma_update_details_post($data, $show_confirmation_page, $show_confirmation, $is_refund, $_data, $confirmed) {
    $change_return_status = $data['change_return_status'];
    $do_tax = true;
    $change_refund_status = true;

	$order_id = empty($change_return_status['order_id']) ? '' : $change_return_status['order_id'];
    $order_info = fn_get_order_info($order_id);
	$template = empty($order_info['payment_method']['template']) ? '' : $order_info['payment_method']['template'];
	$transaction_id = empty($order_info['payment_info']['transaction_id'])
						? ''
						: $order_info['payment_info']['transaction_id'];
	
    $return_statuses = fn_get_statuses(STATUSES_RETURN);
	$return_inventory_status = $return_statuses[$change_return_status['status_to']]['params']['inventory'];
    $return_data = fn_get_return_info($change_return_status['return_id']);
    
/* sq_log(sprintf("%s: is_refund=%d, change_return_status=%s\ndata:%s\n_data:%s\nreturn_data:%s",
	__FUNCTION__,
	$is_refund,
	$change_return_status,
	print_r($data,true),
	print_r($_data,true),
	print_r($return_data,true)
 	)
 );
*/
	$return_order_status = $return_data['status'];
	$refund_order_statuses = array('C');
	$qualify_on_order_status = true;


    if( strpos($template, 'squarepay')	// is squarepay_install_setup
    && $transaction_id	// A transaction_id exists
    && $return_inventory_status != 'D'
    && ($qualify_on_order_status == false || in_array($return_order_status, $refund_order_statuses)) ) {
    	$refund_amount = 0;

		$get_tax = $item_tax_refund = 0;
		if( function_exists('eztj_active_apikey') ) {
			$get_tax = true && $do_tax;
		}
        if (!empty($order_info['returned_products'])) {
            foreach ($order_info['returned_products'] as $cart_id => $product) {
                if (isset($return_data['items']['A'][$cart_id])) {
               	if( $get_tax ) {
                		$item_tax_refund = sq_item_tax($return_data['items']['A'][$cart_id]['amount'], $order_id, $cart_id, $return_data['items']['A'][$cart_id]);
						sq_log(sprintf("%s: item_tax_refund=%.2f, quantity=%d, order_id=%s", 
							__FUNCTION__,
							$item_tax_refund,
							$return_data['items']['A'][$cart_id]['amount'],
							$order_id
							),
							logDetail
						);
                	}
                    $refund_amount += $product['subtotal'] + $item_tax_refund;
					sq_log(sprintf("%s: subtotal=%.2f, refund_amount=%.2f", __FUNCTION__, $product['subtotal'], $refund_amount), logDetail);
                }
            }
        } elseif (!empty($order_info['products'])) {
            foreach ($order_info['products'] as $cart_id => $product) {
                if (isset($product['extra']['returns']) && isset($return_data['items']['A'][$cart_id])) {
                    foreach ($product['extra']['returns'] as $return_id => $product_return_data) {
                    	if( $return_id != $return_data['return_id']) {	// Skip if not this return
                    		continue;
                    	}
                      	if( $get_tax ) {
                    		$item_tax_refund = sq_item_tax($product_return_data['amount'], $order_id, $cart_id, $product);
							sq_log(sprintf("%s: item_tax_refund=%.2f, quantity=%d, order_id=%s", 
								__FUNCTION__,
								$item_tax_refund,
								$product_return_data['amount'],
								$order_id
								), 
								logDetail
							);
                    	}
                        $refund_amount += ($return_data['items']['A'][$cart_id]['price'] * $product_return_data['amount']) + $item_tax_refund;
						 sq_log(sprintf("%s: refund_amount=%.2f", __FUNCTION__, $product_return_data['amount'], $refund_amount), logDetail);
                    }
                }
            }
        }

        if ($refund_amount) {
			$sqObj = new squarepay($order_info['payment_method']['payment_id']);
			$transaction_id = $order_info['payment_info']['transaction_id'];
			$result = $sqObj->tx_refund($order_info['order_id'], $transaction_id, $refund_amount, $change_refund_status == true);
			if( $error = $sqObj->get_error_detail($result) ) {
				fn_set_notification("E", __("error"), $error, 'K');
				sq_log("Refund error: $error");
			} else {
				fn_set_notification("N", __("notice"), "Refunded order_id $order_id in amount of $refund_amount", 'K');
				sq_log("Refunded order_id $order_id in amount of $refund_amount");
			}
        }
    }	
}

function fn_squarepay_update_order_payment_info_before_processing_response( $order_id, $pp_response, &$payment_info) {
	// Clean fields from rcodyomh payment_info
	$fields = [ 'sq_nonce', 'sq_customer_id', 'sq_save_card', 'verification_token' ];
	foreach($fields as $field) {
		unset($payment_info[$field]);
	}
}

if( file_exists($f = dirname(__FILE__)."/class.squarepay.php") )
	include($f);

?>