<?php
if( !defined('BOOTSTRAP') ) die('Access denied');
use Tygh\Registry;

$addon = 'squarepay';

/* Done via sq_install...
if( function_exists('addon_install_lang_vars') ) {
	addon_install_lang_vars($addon, addon_silent_install('squarepay') );
}*/

if( function_exists('sq_install') ) 
	sq_install(array('install_templates'=>true, 'force'=>false));

if( !file_exists($f = Registry::get("config.dir.addons")."/squarepay/upgrade/.tx_converted") ) {
	$age = TIME -(SECONDS_IN_DAY * 60);		// 60 days old
	$count = 0;
	$order_ids = db_get_fields("SELECT order_id FROM ?:orders WHERE timestamp > $age AND is_parent_order = 'N' AND parent_order_id != 0 ORDER BY order_id DESC");
	foreach($order_ids as $order_id) {
		sq_convert_tx($order_id);
		$count++;
	}
	fn_set_notification("N", __("notice"), "Converted $count orders to new transaction format.");
	file_put_contents($f, date("m/d/Y"));
}
if( file_exists($f="design/backend/templates/addons/squarepay/hooks/orders/payment_info.post.tpl"))
	@rename($f, sprintf("X%s", $f));
	
// Convert old locations to new
foreach( sq_payment_ids() as $payment_id) {
	$payment_data = fn_get_payment_method_data($payment_id);
    if( empty($payment_data['processor_params']['sq_access_token']) && !sq_test_site() ) {
        continue;	// Skip one's without access token
    }
	$current_location = empty($payment_data['processor_params']['sq_location']) ? null : $payment_data['processor_params']['sq_location'];
	if( $current_location ) {
		$sqObj = new squarepay($payment_id);
		foreach($sqObj->location_names as $location_id => $location_name) {
			if( $current_location == $location_name ) {	// Old one
				$payment_data['processor_params']['sq_location'] = $location_id;
				fn_update_payment($payment_data, $payment_id);
				fn_set_notification('W', __('notice'), $msg = sprintf(
					"Changed saved location_id for payment method '%s' and location name '%s'",
															$payment_data['payment'], $current_location
														  ) 
									);
				sq_log($msg);
				break;
			}
		}
		$sqObj = null;
	}
}
?>