<!-- Addon - Admin: common/extra_tx.tpl Squareup card data collection user_id={$user_id}-->
{** Determine if we display saved cards **}
{if isset($cart.user_data.user_id)}
	{assign var="user_id" value=$cart.user_data.user_id}
{else}
	{** 11/6/16: Changed from auth.user_id to order_info.user_id **}
	{assign var="user_id" value=$order_info.user_id}
{/if}

{assign var="sq_testing" value=""|sq_testing}
{if $sq_testing}
	{assign var="access_token" value=$smarty.const.SQ_SB_ACCESS_TOKEN}
	{assign var="application_id" value=$smarty.const.SQ_SB_APPLICATION_ID}
	{assign var="web_payments_url" value="https://sandbox.web.squarecdn.com/v1/square.js"}
	{assign var="location_id" value=$smarty.const.SQ_SB_LOCATION_ID}
{else}
	{assign var="access_token" value=$payment_method.processor_params.sq_application_id}
	{assign var="application_id" value=$smarty.const.SQ_APPLICATION_ID}
	{assign var="web_payments_url" value="https://web.squarecdn.com/v1/square.js"}
	{assign var="location_id" value=$payment_method.processor_params.sq_location}
{/if}

<script
  type="text/javascript"
  src="{$web_payments_url}"
></script>
<script>
  var appId = '{$application_id}';
  var locationId = '{$location_id}';
  var cardData = {};
  var sq_dbg = parseInt('{""|sq_debugging}' ? "1" : "0");
console.log("sq_dbg="+parseInt(sq_dbg)+", appId="+appId+", locationId="+appId );

  async function initializeCard(payments) {
	   var card = await payments.card();
	   await card.attach('#card-container');

	   return card;
	 }

	 // verificationToken can be undefined, as it does not apply to all payment methods.
	 async function createPayment(token, verificationToken) {
	   var bodyParameters = {
		 locationId,
		 sourceId: token,
	   };

	   if (verificationToken === undefined) {
		 verificationToken = null;
	   }
		bodyParameters.verificationToken = verificationToken;

	   var body = JSON.stringify(bodyParameters);

	   var paymentResponse = await fetch('/payment', {
		 method: 'POST',
		 headers: {
		   'Content-Type': 'application/json',
		 },
		 body,
	   });

	   if (paymentResponse.ok) {
		 return paymentResponse.json();
	   }

	   var errorBody = await paymentResponse.text();
	   throw new Error(errorBody);
	 }

	 async function tokenize(paymentMethod) {
	   var tokenResult = await paymentMethod.tokenize();
//console.log("tokenize(paymentMethod) tokenResult:"+JSON.stringify(tokenResult,null, 4) );
	   if (tokenResult.status === 'OK') {
		 cardData = tokenResult.details.card;
		 return tokenResult.token;
	   } else {
		 throw new Error(
			{literal}
		   `Tokenization errors: ${JSON.stringify(tokenResult.errors)}`
		   {/literal}
		 );
	   }
	 }

	 // status is either SUCCESS or FAILURE;
	 function displayPaymentResults(status) {
	   var statusContainer = document.getElementById(
		 'payment-status-container'
	   );
	   if (status === 'SUCCESS') {
		 statusContainer.classList.remove('is-failure');
		 statusContainer.classList.add('is-success');
	   } else {
		 statusContainer.classList.remove('is-success');
		 statusContainer.classList.add('is-failure');
	   }

	   statusContainer.style.visibility = 'visible';
	 }

	 async function verifyBuyer(payments, token) {
	   var verificationDetails = {
		 amount: '1.00',
		 billingContact: {
		   addressLines: ['123 Main Street', 'Apartment 1'],
		   familyName: 'Doe',
		   givenName: 'John',
		   email: 'jondoe@gmail.com',
		   country: 'GB',
		   phone: '3214563987',
		   region: 'LND',
		   city: 'London',
		 },
		 currencyCode: 'GBP',
		 intent: 'CHARGE',
	   };

	   var verificationResults = await payments.verifyBuyer(
		 token,
		 verificationDetails
	   );
	   return verificationResults.token;
	 }

//         document.addEventListener('DOMContentLoaded', async function () {
//			await sq_show_payment_form();
//		 });
	 async function sq_show_payment_form() {
	   if (!window.Square) {
		 throw new Error('Square.js failed to load properly');
	   }

	   let payments;
	   try {
		 payments = window.Square.payments(appId, locationId);
	   } catch {
		 var statusContainer = document.getElementById(
		   'payment-status-container'
		 );
		 statusContainer.className = 'missing-credentials';
		 statusContainer.style.visibility = 'visible';
		 return;
	   }

	   let card;
	   try {
		 card = await initializeCard(payments);
	   } catch (e) {
		 console.error('Initializing Card failed', e);
		 return;
	   }

	   async function handlePaymentMethodSubmission(
		 event,
		 paymentMethod,
		 shouldVerify = false
	   ) {
		 event.preventDefault();

		 try {
		   // disable the submit button as we await tokenization and make a payment request.
		   cardButton.disabled = true;
		   var token = await tokenize(paymentMethod);
		   let verificationToken;

		   if (shouldVerify) {
			   try {
				 verificationToken = await verifyBuyer(payments, token);
			   } catch(e) {
				   cardButton.disabled = false;
				   $('#payment-status-container').html('<p>'+e.message+'</p>');
				   displayPaymentResult('FAILURE');
			   }
		   }

//               var paymentResults = await createPayment(
//                 token,
//                verificationToken
//              );
console.debug("token", token, "verificationToken", verificationToken );

		   displayPaymentResults('SUCCESS');
//              console.debug('Payment Success', paymentResults);
			$('#has_sq_nonce').val(token);
			$('#verification_token').val(verificationToken);
// Form/display adjustments here
			adjust_form();
console.log("nonce="+$('#has_sq_nonce').val()+", verification_token="+$('#verification_token').val() );
		 } catch (e) {
		   cardButton.disabled = false;
		   displayPaymentResults('FAILURE');
		   console.error(e.message);
		 }
	   }

	   var cardButton = document.getElementById('card-button');
	   cardButton.addEventListener('click', async function (event) {
		 // SCA only needs to be run for Card Payments. All other payment methods can be set to false.
		 handlePaymentMethodSubmission(event, card, true);
	   });
}
//         });


  function requestCardNonce() {
    sq_show_payment_form();
  }
  
  function submit_refund(order_id, transaction_id, tx_key) {
	refund_amount=$('#refund_amount_'+tx_key).val();
	params='order_id='+order_id+'&transaction_id='+transaction_id+'&refund_amount='+parseInt(parseFloat(refund_amount).toFixed(2) * 100);
//console.log("params="+params);
	window.onbeforeunload = null;
	window.location.href="{"squarepay.tx_refund"|fn_url}&"+params;
  }
  
  function sq_set_required() {
	  $('#reason_label').addClass('cm-required');
	  $('#amount_label').addClass('cm-required');
  }

	function adjust_form() {
		$('#cards input:radio').each(function() {
									$(this).prop('checked',false);
								  });
		// Change the text for the new card radio button
		$('#show_new_card').html(cardData.brand + 
						   " - " + 
						   '{$cart.user_data.b_firstname} {$cart.user_data.b_lastname} - ***' + 
						   cardData.last4 + ' - ' + 
						   cardData.expMonth + '/' + cardData.expYear);
		// And check it
sq_dbg && console.log("Card data html = "+$('#show_new_card').html() );
		$('#new_card_input').prop('checked',true);
		$('#new_card_input2').prop('checked',true);
		// Show the save card checkbox
		// Disable the onclick event
		$('#new_card_input').click(function() {
											});
		$('#new_card_input2').click(function() {
											});
	
		// Hide the div that shows the card data collection		  
		$('#no_nonce').hide();
		// Show the response div
		$('#has_nonce').show();
		$('#save_card').hide();
sq_dbg && console.log("#has_nonce -> show(), #save_card -> hide");
	
		// If reset card is clicked
		//	- reset the html to show the enter card text
		//  - re-enable the onclick event
		//  - hide the response div
		//	- clear the nonce value
		$('#sq_reset_card').click( function() {
									$('#show_new_card').html('{__("sq_or_enter_new_card")}');
									$('#new_card_input').click( function() {
																	  $('#no_nonce').show();
																	  });
									$('#new_card_input2').click( function() {
																	  $('#no_nonce').show();
																	  });
									$('#has_nonce').hide();
									$('#has_sq_nonce').val('');
									$('#save_card').hide();
								  });
		// submit the order
	}	// function adjust_fomr

</script>
  
  <style type="text/css">
    .sq-input {
      border: 1px solid rgb(223, 223, 223);
      outline-offset: -2px;
      margin-bottom: 5px;
    }
    .sq-input--focus {
      /* how your inputs should appear when they have focus */
      outline: 5px auto rgb(59, 153, 252);
    }
    .sq-input--error {
      /* how your inputs should appear when invalid */
      outline: 5px auto rgb(255, 97, 97);
    }
	.sq-div {
		padding-bottom:20px;
	}
  </style>  
{if $order_transactions|count > 1}
{assign var="extra_tx" value=$smarty.request.order_id|sq_get_tx_data}
{if $extra_tx}
	<div id="extra_tx">
		{include file="common/subheader.tpl" title=__("sq_extra_payments")}
		{foreach name="ex" key="tx_key" from=$extra_tx item="tx"}
			{if $tx_key == $p_info.transaction_id}
				{continue}
			{/if}
			<div class="control-group">
				{assign var="pay_info" value=$tx|sq_tx_to_pay}
				{foreach from=$pay_info key="k" item="v"}
					<div class="control-group">
						<label class="control-label" for="_{$k}">{__("$k")}:</label>
						<div id="_{$k}" class="controls">{$v}</div>
					</div>
				{/foreach}
				{include file="addons/squarepay/common/tx_buttons.tpl" p_info=$tx order_id=$smarty.request.order_id tx_key=$tx_key}
				<hr style="border-bottom: 2px solid black;"/>	
			</div>		
		{/foreach}
	</div>
{/if} {* extra_tx *}
{/if} {* order transactions *}

{assign var="allow_new_charge" value=false}

{if $allow_new_charge == false || ( "MULTIVENDOR"|fn_allowed_for && $runtime.company_id)}
	{* do nothing *}
{else}
	<div id="new_charge_button" style="padding-bottom:20px;">
		  {include file="buttons/button.tpl" 
		  but_text=__('sq_new_charge') 
		  but_onclick="$('#new_charge').toggle();$('#new_charge_button').toggle();sq_set_required();" 
		  but_id="sq_charge" 
		  but_meta="cm-no-ajax btn-primary" 
		  but_role="action" }
	</div>
	
	
	{** Show this div if the New charge button is pressed **}
	<div id="new_charge" class="hidden">
		<input type="hidden" name="order_info[order_id]" value="{$order_info.order_id}" />
		<div class="control-group">
			<label id="reason_label" class="control-label" for="reason">{__("sq_reason")}</label>
			<div class="controls">
				<input id="reason" type="text" class="input-medium" name="order_info[reason]" value="" />
			</div>
		</div>
		<div class="control-group">
			<label id="amount_label" class="control-label" for="amount">{__("sq_extra_amount")}</label>
			<div class="controls">
				<input id="amount" type="text" class="input-small" name="order_info[total]" value="" />
			</div>
		</div>

		<div id="sq_container" style="padding-bottom:20px;">
			{** Determine if we display saved cards **}
			{** 11/6/16: Changed from auth.user_id to user_id **}
			{if $user_id}
				{** 11/6/16: Changed from auth.user_id to user_id **}
				{assign var="sq_data" value=$user_id|sq_get_user_sq_data}
				{if $sq_data}	{** User is existing square customer **}
					{assign var="customer_id" value=$sq_data.id}
					<input type="hidden" name="order_info[payment_info][sq_customer_id]" value="{$customer_id}" />
					{** 11/6/16: Changed from auth.user_id to user_id **}
					{assign var="card_strings" value=$user_id|sq_checkout_cards:$payment_id}
				{/if}
				{if $card_strings}	{** user has stored card info **}
					<div id="cards" style="padding-left:30px;">
						<h3>{__("sq_select_card_header__orders")}</h3>
						<ul>
						{foreach name="c" from=$card_strings key="card_id" item="card_string"}
							<li><input type="radio" name="order_info[payment_info][sq_card_id]" value="{$card_id}" {if $smarty.foreach.c.first}checked="checked"{/if} />{$card_string nofilter}
							</li>
						{/foreach}
						<li>
							<input id="new_card_input" type="radio" name="order_info[payment_info][sq_card_id]" value="" 
								onclick="$('#no_nonce').show();sq_show_payment_form();"><span id="show_new_card">{__("sq_or_enter_new_card")}</span>
							<input type="hidden" name="order_info[payment_info][sq_save_card]" value="" />
							{** 11/6/16: Changed from auth.user_id to user_id **}
							{if $user_id && $addons.squarepay.always_save_cards != "Y"}
								<ul id="save_card" class="hidden">
									<li><input type="checkbox" name="order_info[payment_info][sq_save_card]" value="1" checked="checked" />{__("sq_save_card")}
									</li>
								</ul>
							{/if}
						</li>
						</ul>
					</div> {** cards **}
				{/if}
			{else}
				<div style="padding-left:30px;">
					<h3>{__("sq_checkout_header")}</h3>
				</div>
			{/if}
			
			{** This div is hidden but displays when new card data is to be collected **}
			{** 11/6/16: Changed from auth.user_id to user_id **}
			<div id="no_nonce" style="padding-left:30px;" class="ty-controls sq-div{if $user_id && $card_strings} hidden{/if}">
				<div id="card-container"></div>
				<div class="sq-notice" >{__("sq_sca_notice")}</div>
				<button id="card-button" type="button">{__("sq_submit_card")}</button>
				{if $sq_testing}
					<div id="payment-status-container"></div>
				{/if}
				<div id="save_card">
					<input type="hidden" name="payment_info[sq_save_card]" 
						value="{if $auth.user_id && $addons.squarepay.always_save_cards == 'Y'}1{else}0{/if}" 
					/>
					{if $auth.user_id && $addons.squarepay.always_save_cards == "N" } 
						<input type="checkbox" id="sq_save_card" name="payment_info[sq_save_card]" 
							value="1" checked="checked" 
						/>
						<label for="sq_save_card" class="ty-control-group__item">{__("sq_save_card")}</label>
					{/if}
				</div>
			</div> {** no_nonce **}
			
			{** This div is shown AFTER a nonce is received from square **}
			<div id="has_nonce" style="padding-left:30px;" class="ty-controls sq-div hidden">
				{if !$card_strings }
					<ul>
						<li>
							<input id="new_card_input2" type="radio" name="payment_info[sq_card_id]" value="" 
								onclick="$('#no_nonce').show();"><span id="show_new_card">{__("sq_or_enter_new_card")}</span>
						</li>
					</ul>
				{/if}
				<input type="hidden" id="has_sq_nonce" name="payment_info[sq_nonce]" value="{$order_info.payment_info.sq_nonce}" />
				{** SCA **}
				<input type="hidden" id="verification_token" name="payment_info[verification_token]" value="{$order_info.payment_info.verification_token}" />
				{** SCA **}
				{if $auth.user_id && $card_strings && $card_strings|count > 1}
					{include file="buttons/button.tpl" but_text=__('sq_reset_card') but_href="checkout.checkout" but_id="sq_reset_card" but_role="none" }
				{/if}
			</div> {** has_nonce **}

		    {include file="buttons/button.tpl" 
				but_text=__('sq_submit_charge')  
				but_id="sq_submit_charge" 
				but_meta="cm-no-ajax" 
				but_name="dispatch[squarepay.tx_charge]"
				but_role="submit" 
		    }
		</div>	{** sq_container **}
	</div>	{** new_charge **}
{/if} {* allow_new_charge  || multivendor *}
