<!-- Addon - Backend: Squareup edit order -->

{assign var="sq_testing" value=""|sq_testing}
{if $sq_testing}
	{assign var="access_token" value=$smarty.const.SQ_SB_ACCESS_TOKEN}
	{assign var="application_id" value=$smarty.const.SQ_SB_APPLICATION_ID}
	{assign var="web_payments_url" value="https://sandbox.web.squarecdn.com/v1/square.js"}
	{assign var="location_id" value=$smarty.const.SQ_SB_LOCATION_ID}
{else}
	{assign var="access_token" value=$payment_method.processor_params.sq_application_id}
	{assign var="application_id" value=$smarty.const.SQ_APPLICATION_ID}
	{assign var="web_payments_url" value="https://web.squarecdn.com/v1/square.js"}
	{assign var="location_id" value=$payment_method.processor_params.sq_location}
{/if}

<div style="padding-bottom:20px;">
	{** Determine if we display saved cards **}
	{if $auth.user_id}
		{assign var="sq_data" value=$auth.user_id|sq_get_user_sq_data}
		{if $sq_data}	{** User is existing square customer **}
			{assign var="customer_id" value=$sq_data.customer_id}
			<input type="hidden" name="payment_info[sq_customer_id]" value="{$customer_id}" />
			{assign var="card_strings" value=$auth.user_id|sq_checkout_cards:$payment_id}
		{/if}
		{if $card_strings}	{** user has stored card info **}
			<div id="cards" style="padding-left:30px;">
				<h3>{__("sq_select_card_header")}</h3>
				<ul>
				{foreach name="c" from=$card_strings key="card_id" item="card_string"}
					<li><input type="radio" name="payment_info[sq_card_id]" value="{$card_id}" {if $smarty.foreach.c.first}checked="checked"{/if} />{$card_string nofilter}
					</li>
				{/foreach}
				<li>
					<input id="new_card_input" type="radio" name="payment_info[sq_card_id]" value="" 
						onclick="$('#no_nonce').show();sq_show_payment_form();"><span id="show_new_card">{__("sq_or_enter_new_card")}</span>
				</li>
				</ul>
			</div>
		{/if}
	{else}
		<div style="padding-left:30px;">
			<h3>{__("sq_checkout_header")}</h3>
		</div>
	{/if}
	
	{** This div is hidden but displays when new card data is to be collected **}
	<div id="no_nonce" style="padding-left:30px;max-width:80%" class="ty-controls sq-div{if $auth.user_id && $card_strings} hidden{/if}">
		<div id="card-container"></div>
		<div class="sq-notice" >{__("sq_sca_notice")}</div>
      	<button id="card-button" type="button">{__("sq_submit_card")}</button>
		{if $sq_testing}
			<div id="payment-status-container"></div>
		{/if}
		<div id="save_card">
			<input type="hidden" name="payment_info[sq_save_card]" 
				value="{if $auth.user_id && $addons.squarepay.always_save_cards == 'Y'}1{else}0{/if}" 
			/>
			{if $auth.user_id && $addons.squarepay.always_save_cards == "N" } 
				<input type="checkbox" id="sq_save_card" name="payment_info[sq_save_card]" 
					value="1" checked="checked" 
				/>
				<label for="sq_save_card" class="ty-control-group__item">{__("sq_save_card")}</label>
			{/if}
		</div>
	</div>
	
	{** This div is shown AFTER a nonce is received from square **}
	<div id="has_nonce" style="padding-left:30px;" class="ty-controls sq-div hidden">
		{if !$card_strings }
			<ul>
				<li>
					<input id="new_card_input2" type="radio" name="payment_info[sq_card_id]" value="" 
						onclick="$('#no_nonce').show();"><span id="show_new_card">{__("sq_or_enter_new_card")}</span>
				</li>
			</ul>
		{/if}
		<input type="hidden" id="has_sq_nonce" name="payment_info[sq_nonce]" value="{$order_info.payment_info.sq_nonce}" />
		{** SCA **}
		<input type="hidden" id="verification_token" name="payment_info[verification_token]" value="{$order_info.payment_info.verification_token}" />
		{** SCA **}
		{if $auth.user_id && $card_strings && $card_strings|count > 1}
	  		{include file="buttons/button.tpl" but_text=__('sq_reset_card') but_href="checkout.checkout" but_id="sq_reset_card" but_role="none" }
		{/if}
	</div>
</div>

    <script
      type="text/javascript"
      src="{$web_payments_url}"
    ></script>
    <script>
      var appId = '{$application_id}';
      var locationId = '{$location_id}';
	  var cardData = {};
console.log("web_payments_url={$web_payments_url}, appId={$application_id}, locationId={$location_id}");

      async function initializeCard(payments) {
           var card = await payments.card();
           await card.attach('#card-container');

           return card;
         }

         // verificationToken can be undefined, as it does not apply to all payment methods.
         async function createPayment(token, verificationToken) {
           var bodyParameters = {
             locationId,
             sourceId: token,
           };

           if (verificationToken !== undefined) {
             bodyParameters.verificationToken = verificationToken;
           }

           var body = JSON.stringify(bodyParameters);

           var paymentResponse = await fetch('/payment', {
             method: 'POST',
             headers: {
               'Content-Type': 'application/json',
             },
             body,
           });

           if (paymentResponse.ok) {
             return paymentResponse.json();
           }

           var errorBody = await paymentResponse.text();
           throw new Error(errorBody);
         }

         async function tokenize(paymentMethod) {
           var tokenResult = await paymentMethod.tokenize();
console.log("tokenize(paymentMethod) tokenResult:"+JSON.stringify(tokenResult,null, 4) );
           if (tokenResult.status === 'OK') {
			 cardData = tokenResult.details.card;
             return tokenResult.token;
           } else {
             throw new Error(
				{literal}
               `Tokenization errors: ${JSON.stringify(tokenResult.errors)}`
			   {/literal}
             );
           }
         }

         // status is either SUCCESS or FAILURE;
         function displayPaymentResults(status) {
           var statusContainer = document.getElementById(
             'payment-status-container'
           );
           if (status === 'SUCCESS') {
             statusContainer.classList.remove('is-failure');
             statusContainer.classList.add('is-success');
           } else {
             statusContainer.classList.remove('is-success');
             statusContainer.classList.add('is-failure');
           }

           statusContainer.style.visibility = 'visible';
         }

         async function verifyBuyer(payments, token) {
           var verificationDetails = {
             amount: '1.00',
             billingContact: {
               addressLines: ['123 Main Street', 'Apartment 1'],
               familyName: 'Doe',
               givenName: 'John',
               email: 'jondoe@gmail.com',
               country: 'GB',
               phone: '3214563987',
               region: 'LND',
               city: 'London',
             },
             currencyCode: 'GBP',
             intent: 'CHARGE',
           };

           var verificationResults = await payments.verifyBuyer(
             token,
             verificationDetails
           );
           return verificationResults.token;
         }

//         document.addEventListener('DOMContentLoaded', async function () {
//			await sq_show_payment_form();
//		 });
		 async function sq_show_payment_form() {
           if (!window.Square) {
             throw new Error('Square.js failed to load properly');
           }

           let payments;
           try {
             payments = window.Square.payments(appId, locationId);
           } catch {
             var statusContainer = document.getElementById(
               'payment-status-container'
             );
             statusContainer.className = 'missing-credentials';
             statusContainer.style.visibility = 'visible';
             return;
           }

           let card;
           try {
             card = await initializeCard(payments);
           } catch (e) {
             console.error('Initializing Card failed', e);
             return;
           }

           async function handlePaymentMethodSubmission(
             event,
             paymentMethod,
             shouldVerify = false
           ) {
             event.preventDefault();

             try {
               // disable the submit button as we await tokenization and make a payment request.
               cardButton.disabled = true;
               var token = await tokenize(paymentMethod);
               let verificationToken;

               if (shouldVerify) {
				   try {
	                 verificationToken = await verifyBuyer(payments, token);
				   } catch(e) {
					   cardButton.disabled = false;
					   $('#payment-status-container').html('<p>'+e.message+'</p>');
					   displayPaymentResult('FAILURE');
				   }
               }

//               var paymentResults = await createPayment(
//                 token,
//                verificationToken
//              );
console.debug("token", token, "verificationToken", verificationToken );

               displayPaymentResults('SUCCESS');
 //              console.debug('Payment Success', paymentResults);
				$('#has_sq_nonce').val(token);
				$('#verification_token').val(verificationToken);
// Form/display adjustments here
				adjust_form();
				$(but_id).show();
console.log("nonce="+$('#has_sq_nonce').val()+", verification_token="+$('#verification_token').val() );
             } catch (e) {
               cardButton.disabled = false;
               displayPaymentResults('FAILURE');
               console.error(e.message);
             }
           }

           var cardButton = document.getElementById('card-button');
           cardButton.addEventListener('click', async function (event) {
             // SCA only needs to be run for Card Payments. All other payment methods can be set to false.
             handlePaymentMethodSubmission(event, card, true);
           });
	}
//         });
	</script>

{** Seems to be necessary when switching between payment TABS versus payment methods within a TAB **}

{if $payment_method.processor_params.sq_application_id }
<script type="text/javascript" class="cm-ajax-force">
	var sq_dbg = parseInt('{""|sq_debugging}' ? "1" : "0");
console.log("sq_dbg="+parseInt(sq_dbg)+", tab_id={$tab_id}" );
	var sq_nonce_responded = false;
	var sq_nonce_used = false;
	var but_id = $("[id^=place_order_{$tab_id}]").length 
				? "[id^=place_order_{$tab_id}]" 
				: ($('#litecheckout_place_order').length
					? '#litecheckout_place_order'
					: '');	
	// SCA
	{assign var="jcart" value=""|sq_cart_verification_fields|json_encode}
	{assign var="jcart" value=$jcart}
	var cart = JSON.parse('{$jcart nofilter}');
	function cartField(fieldname, default_value) {
		var prefixes = ['b_', '', 's_'];
		for( i in prefixes ) {
			if( typeof(cart[prefixes[i]+fieldname]) !== 'undefined' && cart[prefixes[i]+fieldname] )
				return cart[prefixes[i]+fieldname];
		}
		return default_value ? default_value : '';
	}
	var verificationDetails = { 
     intent: 'CHARGE', 
     amount: '{$cart.total}', 
     currencyCode: '{$smarty.const.PRIMARY_CURRENCY}', 
     billingContact: {
       givenName: cartField('firstname', 'unknown'),
       familyName: cartField('lastname', ''),
	   addressLines: [ cartField('address'), cartField('address_2') ],
	   email: cartField('email'),
	   country: cartField('country'),
	   phone: cartField('phone'),
	   region: cartField('state'),
	   city: cartField('city')	   
     }
   }; 
//sq_dbg && console.log("verificationDetails:"+JSON.stringify(verificationDetails,null,4) );
	// SCA
	
	function adjust_form() {
		$('#cards input:radio').each(function() {
									$(this).prop('checked',false);
								  });
		// Change the text for the new card radio button
		$('#show_new_card').html(cardData.brand + 
						   " - " + 
						   '{$cart.user_data.b_firstname} {$cart.user_data.b_lastname} - ***' + 
						   cardData.last4 + ' - ' + 
						   cardData.expMonth + '/' + cardData.expYear);
		// And check it
//sq_dbg && console.log("Card data html = "+$('#show_new_card').html() );
		$('#new_card_input').prop('checked',true);
		$('#new_card_input2').prop('checked',true);
		// Show the save card checkbox
		$('#save_card').show();
		// Disable the onclick event
		$('#new_card_input').click(function() {
											});
		$('#new_card_input2').click(function() {
											});
  
		// Hide the div that shows the card data collection		  
		$('#no_nonce').hide();
		// Show the response div
		$('#has_nonce').show();
sq_dbg && console.log("#has_nonce -> show()");
	
		// If reset card is clicked
		//	- reset the html to show the enter card text
		//  - re-enable the onclick event
		//  - hide the response div
		//	- clear the nonce value
		$('#sq_reset_card').click( function() {
									$('#show_new_card').html('{__("sq_or_enter_new_card")}');
									$('#new_card_input').click( function() {
																	  $('#no_nonce').show();
																	  });
									$('#new_card_input2').click( function() {
																	  $('#no_nonce').show();
																	  });
									$('#has_nonce').hide();
									$('#has_sq_nonce').val('');
									$('#save_card').hide();
								  });
		// submit the order
{*
		// Note that between 10.4.2 and 10.4.3 cs-cart fixed the typo for litechekout_payment_form
sq_dbg && console.log("payments_form_ length="+$("form[name='payments_form_{$tab_id}']").length +
", litecheckout_payments_form length="+$('#litecheckout_payments_form').length);
		if( $("form[name='payments_form_{$tab_id}']").length )	{
			sq_formname = "form[name='payments_form_{$tab_id}']";
sq_dbg && console.log("Using pre 4.10.3 payment method");
		} else if($('#litecheckout_payments_form').length) {
			sq_formname = "#litecheckout_payments_form";
sq_dbg && console.log("Using 4.10.3+ form ("+sq_formname+")");
		}
sq_dbg && console.log("Submitting form "+sq_formname+":"+JSON.stringify($(sq_formname).serializeArray(),null,4));
		$(sq_formname).submit();
*}
	}


	// Allow submit button to submit card
	$(document).ready( function() {
sq_dbg && console.log("But_id="+but_id);
		var sq_payment = typeof($('input[name=payment_id]').val()) == 'undefined'
							|| $('input[name=payment_id]').val() == '{$payment_id}';
							
		// if user does not have saved cards, hide the submit button, else show it
		 if( sq_payment ) {
			{if !$card_strings} 
sq_dbg && console.log("sq_payment="+sq_payment+', card_strings is NOT set');
				$(but_id).hide();	// Don't hide if $card_strings is set.
			{else}
sq_dbg && console.log("Card strings IS set.  Not hiding button.");
				$(but_id).show();	// default is to show
			{/if}
		}
		
		$(but_id).click(function() {
//		$("[id^=place_order_{$tab_id}]", "#litecheckout_place_order").click(function() {
			// Have entered card data and we're currently using this payment method
			// handle case of no other payment methods
			// 1/28/17: Changed to remove the 'type' since this changed from a radio to a hidden input
			sq_payment = typeof($('input[name=payment_id]').val()) == 'undefined'
							|| $('input[name=payment_id]').val() == '{$payment_id}';
sq_dbg && console.log("Submit button clicked, sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
			if( sq_nonce_used && sq_payment) {
				$("[id^=place_order_{$tab_id}]", "#litecheckout_place_order").hide();	// Hide the submit button while we preocess
				requestCardNonce();
sq_dbg && console.log("requestCardNonce called on click of Submit order button, returning false");
				return false;
			} else if( sq_payment) {	// No nonce
				if( card_id=$("name=[sq_card_id]").val() ) {	// No nonce, but there is a card_id set
					try {
					 payments = window.Square.payments(appId, locationId);
					} catch {
					   $('#payment-status-container').html('<p>'+e.message+'</p>');
					   displayPaymentResult('FAILURE');
						return false;
					}
					var verificationResults = payments.verifyBuyer(
             				card_id,
             				verificationDetails
           			);
					$('#verification_token').val(verificationResults.token);	// Set the token
console.log("Place order: submitted with card_id: sq_payment="+sq_payment+",  verification_token="+verificationResults.token);
					return true;
				} else {
console.log("Place order: submitted order without Nonce (no card_id): sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
					return true;
				}
			}
		});
		// 7/29/17: Support for 'repay' orders from admin or for udated orders
		// Same thing but for the 'repay' button
		$("button[name='dispatch[orders.repay]']").click(function() {
			sq_payment = typeof($('input[name=payment_id]').val()) == 'undefined'
				|| $('input[name=payment_id]').val() == '{$payment_id}';
sq_dbg && console.log("Repay clicked: sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
			if( sq_nonce_used && sq_payment) {
				$("button[name='dispatch[orders.repay]']").hide();	// Hide the repay button while we preocess
				$("input[name=dispatch]").val('orders.repay');
				sq_show_payment_form();
				return false;
			} else {
console.log("Repay: submitted order without Nonce: sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
				return true;
			}
		});

sq_dbg && console.log("Click event set for id="+but_id);
		if(  sq_payment && parseInt('{empty($card_strings)}') ) {
			$('#card-container').html('');	// Clear it for possible reloads.
//			$('#save_card').hide();
			sq_show_payment_form();	
		}
	});
</script>
{/if} {** sq_application_id **}
