<!-- Addon - Client: Squareup card data collection - original -->
{*<!--  TB: cart:{$cart|print_r:true} -->*} 
  <style type="text/css">
    .sq-input {
      border: 1px solid rgb(223, 223, 223);
      outline-offset: -2px;
      margin-bottom: 5px;
  
    }
    .sq-input--focus {
      /* how your inputs should appear when they have focus */
      outline: 5px auto rgb(59, 153, 252);
    }
    .sq-input--error {
      /* how your inputs should appear when invalid */
      outline: 5px auto rgb(255, 97, 97);
    }
	.sq-div {
		padding-bottom:20px;
	}
  </style>  

<div style="padding-bottom:20px;">
	{** Determine if we display saved cards **}
	{if $auth.user_id}
		{assign var="sq_data" value=$auth.user_id|sq_get_user_sq_data}
		{if $sq_data}	{** User is existing square customer **}
			{assign var="customer_id" value=$sq_data.id}
			<input type="hidden" name="payment_info[sq_customer_id]" value="{$customer_id}" />
			{assign var="card_strings" value=$auth.user_id|sq_checkout_cards:$payment_id}
		{/if}
		{if $card_strings}	{** user has stored card info **}
			<div id="cards" style="padding-left:30px;">
				<h3>{__("sq_select_card_header")}</h3>
				<ul>
				{foreach name="c" from=$card_strings key="card_id" item="card_string"}
					<li><input type="radio" name="payment_info[sq_card_id]" value="{$card_id}" {if $smarty.foreach.c.first}checked="checked"{/if} />{$card_string nofilter}
					</li>
				{/foreach}
				<li>
					<input id="new_card_input" type="radio" name="payment_info[sq_card_id]" value="" 
						onclick="$('#no_nonce').show();"><span id="show_new_card">{__("sq_or_enter_new_card")}</span>
				</li>
				</ul>
			</div>
		{/if}
	{else}
		<div style="padding-left:30px;">
			<h3>{__("sq_checkout_header")}</h3>
		</div>
	{/if}
	
	{** This div is hidden but displays when new card data is to be collected **}
	<div id="no_nonce" style="padding-left:30px;max-width:80%" class="ty-controls sq-div{if $auth.user_id && $card_strings} hidden{/if}">
		<label for="sq-card-number" class="ty-control-group__title">{if $auth.user_id && $card_strings}{__("new")|ucwords} {/if}{__("sq_card_number")}:&nbsp;</label>
		<div id="sq-card-number" class="ty-control-group"></div>
		<label  for="sq-expiration-date" class="ty-control-group__title">
			{__("sq_expiration_date")}:&nbsp;
		</label>
		<div id="sq-expiration-date" class="ty-control-group"></div>
		<label  for="sq-cvv" class="ty-control-group__title">{__("sq_cvv_code")}:&nbsp;</label>
		<div id="sq-cvv" class="ty-control-group"></div>
		<label  for="sq-postal-code" class="ty-control-group__title">{__("sq_postal_code")}:&nbsp;</label>
		<div id="sq-postal-code" class="ty-control-group"></div>
		<p>{__("sq_postal_code_hint")}</p>
		<input type="hidden" id="sq_nonce" name="payment_info[sq_nonce]" value="" />
		<div id="sq_nonce_errors">
		</div>
		<input type="hidden" name="payment_info[sq_save_card]" 
			value="{if $auth.user_id && $addons.squarepay.always_save_carts == 'Y'}1{else}0{/if}" 
		/>
		{if $auth.user_id && $addons.squarepay.always_save_cards == "N" } 
			<input type="checkbox" id="sq_save_card" name="payment_info[sq_save_card]" 
				value="1" checked="checked" 
			/>
			<label for="sq_save_card" class="ty-control-group__item">{__("sq_save_card")}</label>
	  {/if}
	</div>
	
	{** This div is shown AFTER a nonce is received from square **}
	<div id="has_nonce" style="padding-left:30px;" class="ty-controls sq-div hidden">
		{if !$card_strings }
			<ul>
				<li>
					<input id="new_card_input2" type="radio" name="payment_info[sq_card_id]" value="" 
						onclick="$('#no_nonce').show();"><span id="show_new_card">{__("sq_or_enter_new_card")}</span>
				</li>
			</ul>
		{/if}
		<input type="hidden" id="has_sq_nonce" name="payment_info[sq_nonce]" value="{$order_info.payment_info.sq_nonce}" />
		{if $auth.user_id && $card_strings && $card_strings|count > 1}
	  		{include file="buttons/button.tpl" but_text=__('sq_reset_card') but_href="checkout.checkout" but_id="sq_reset_card" but_role="none" }
		{/if}
	</div>
</div>

<script type="text/javascript" src="https://js.squareup.com/v2/paymentform" class="cm-ajax-force"></script>

{** Seems to be necessary when switching between payment TABS versus payment methods within a TAB **}
{if $payment_method.processor_params.sq_application_id }
<script type="text/javascript" class="cm-ajax-force">
	var sq_dbg = parseInt('{""|sq_debugging}' ? "1" : "0");
	var sq_nonce_responded = false;
	var sq_nonce_used = false;
	var but_id = $("[id^=place_order_{$tab_id}]").length 
				? "[id^=place_order_{$tab_id}]" 
				: ($('#litecheckout_place_order').length
					? '#litecheckout_place_order'
					: '');
	var sq_formname = '';		// Set when we identify which button we're using.
	var paymentForm = new SqPaymentForm({
		applicationId: '{$payment_method.processor_params.sq_application_id}',
		inputClass: 'sq-input',
		inputStyles: [
			{
				fontSize: '15px',
				padding: '0.94em 0.8em'
			}
		],
		cardNumber: {
			elementId: 'sq-card-number',
			placeholder: 'XXXX XXXX XXXX XXXX'
		},
		expirationDate: {
			elementId: 'sq-expiration-date',
			placeholder: 'MMYY'
		},
		cvv: {
			elementId: 'sq-cvv',
			placeholder: '{__("sq_cvv")}'
		},
		postalCode: {
			elementId: 'sq-postal-code',
			placeholder: '{__("sq_from_card_statement")}'
		},
		callbacks: {
			cardNonceResponseReceived: function(errors, nonce, cardData) {
sq_dbg && console.log("responseReceived: errors:"+JSON.stringify(errors,null,4)+", nonce="+nonce+", card_data:"+JSON.stringify(cardData,null,4) );
				if (errors) {
					// handle errors
					errors.forEach(function(error) { 
									  console.log(error.message); 
									  html = $('#sq_nonce_errors').html();
									  html += "<p style=\"color:red;\">"+error.message+"</p>";
									  $('#sq_nonce_errors').html(html);
									  });
					$(but_Id).show();
					// Show the submit button again
					$("button[name='dispatch[orders.repay]']").show();	// Show the submit button again
					return false;
				} else {
sq_dbg && console.log('No error: Nonce received: '+nonce);
					// set the value for the cart input
					$('#sq_nonce').val(nonce);
					$('#has_sq_nonce').val(nonce);
			
sq_dbg && console.log("#sq_nonce.val()="+$('#sq_nonce').val() );
sq_dbg && console.log("#has_sq_nonce.val()="+$('#has_sq_nonce').val() );
					// Uncheck all the radio buttons
					$('#cards input:radio').each(function() {
												$(this).prop('checked',false);
											  });
					// Change the text for the new card radio button
					$('#show_new_card').html(cardData.card_brand + 
									   " - " + 
									   '{$cart.user_data.b_firstname} {$cart.user_data.b_lastname} - ***' + 
									   cardData.last_4 + ' - ' + 
									   cardData.exp_month + '/' + cardData.exp_year);
					// And check it
					$('#new_card_input').prop('checked',true);
					$('#new_card_input2').prop('checked',true);
					// Show the save card checkbox
					$('#save_card').show();
					// Disable the onclick event
					$('#new_card_input').click(function() {
														});
					$('#new_card_input2').click(function() {
														});
			  
					// Hide the div that shows the card data collection		  
					$('#no_nonce').hide();
					// Show the response div
					$('#has_nonce').show();
				
					// If reset card is clicked
					//	- reset the html to show the enter card text
					//  - re-enable the onclick event
					//  - hide the response div
					//	- clear the nonce value
					$('#sq_reset_card').click( function() {
												$('#show_new_card').html('{__("sq_or_enter_new_card")}');
												$('#new_card_input').click( function() {
																				  $('#no_nonce').show();
																				  });
											 	$('#new_card_input2').click( function() {
																				  $('#no_nonce').show();
																				  });
												$('#has_nonce').hide();
												$('#sq_nonce').val('');
												$('#has_sq_nonce').val('');
												$('#save_card').hide();
											  });
					// submit the order
					// Note that between 10.4.2 and 10.4.3 cs-cart fixed the typo for litechekout_payment_form
sq_dbg && console.log("payments_form_ length="+$("form[name='payments_form_{$tab_id}']").length +
", litecheckout_payments_form length="+$('#litecheckout_payments_form').length);
					if( $("form[name='payments_form_{$tab_id}']").length )	{
						sq_formname = "form[name='payments_form_{$tab_id}']";
sq_dbg && console.log("Using pre 4.10.3 payment method");
					} else if($('#litecheckout_payments_form').length) {
						sq_formname = "#litecheckout_payments_form";
sq_dbg && console.log("Using 4.10.3+ form ("+sq_formname+")");
					}
sq_dbg && console.log("Submitting form "+sq_formname+":"+JSON.stringify($(sq_formname).serializeArray(),null,4));
					$(sq_formname).submit();
				}
				return true;
		},
		unsupportedBrowserDetected: function() {
			alert("Unsupported browser detected");
			// Alert the buyer that their browser is not supported
		},
		inputEventReceived: function(inputEvent) {
				switch (inputEvent.eventType) {
					case 'focusClassAdded':
						// Handle as desired
						break;
					case 'focusClassRemoved':
						// Handle as desired
						break;
					case 'errorClassAdded':
						// Handle as desired
						break;
					case 'errorClassRemoved':
						// Handle as desired
						break;
					case 'cardBrandChanged':
						// Handle as desired
						 break;
					case 'postalCodeChanged':
						sq_nonce_used = true;	// tell click handler we have nonce form data
sq_dbg && console.log("InputEventReceived: "+ inputEvent.eventType+", sq_nonce_used="+sq_nonce_used);
						$(but_id).show();
						break;
				}
			}
		}
	});
  
	function requestCardNonce() {
		paymentForm.requestCardNonce();
	}
	

	// Load the form or stored payment info
	paymentForm.build();
		
	// Allow submit button to submit card
	$(document).ready( function() {
sq_dbg && console.log("But_id="+but_id);
		var sq_payment = typeof($('input[name=payment_id]').val()) == 'undefined'
							|| $('input[name=payment_id]').val() == '{$payment_id}';
							
		// if user does not have saved cards, hide the submit button, else show it
		 if( sq_payment ) {
			{if !$card_strings} 
sq_dbg && console.log("sq_payment="+sq_payment+', card_strings is NOT set');
				$(but_id).hide();	// Don't hide if $card_strings is set.
			{else}
sq_dbg && console.log("Card strings IS set.  Not hiding button.");
				$(but_id).show();	// default is to show
			{/if}
		}
		
		$(but_id).click(function() {
//		$("[id^=place_order_{$tab_id}]", "#litecheckout_place_order").click(function() {
			// Have entered card data and we're currently using this payment method
			// handle case of no other payment methods
			// 1/28/17: Changed to remove the 'type' since this changed from a radio to a hidden input
			sq_payment = typeof($('input[name=payment_id]').val()) == 'undefined'
							|| $('input[name=payment_id]').val() == '{$payment_id}';
sq_dbg && console.log("Submit button clicked, sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
			if( sq_nonce_used && sq_payment) {
				$("[id^=place_order_{$tab_id}]", "#litecheckout_place_order").hide();	// Hide the submit button while we preocess
				requestCardNonce();
sq_dbg && console.log("requestCardNonce called on click of Submit order button, returning false");
				return false;
			} else {
console.log("Place order: submitted order without Nonce: sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
				return true;
			}
		});
		// 7/29/17: Support for 'repay' orders from admin or for udated orders
		// Same thing but for the 'repay' button
		$("button[name='dispatch[orders.repay]']").click(function() {
			sq_payment = typeof($('input[name=payment_id]').val()) == 'undefined'
				|| $('input[name=payment_id]').val() == '{$payment_id}';
sq_dbg && console.log("Repay clicked: sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
			if( sq_nonce_used && sq_payment) {
				$("button[name='dispatch[orders.repay]']").hide();	// Hide the repay button while we preocess
				$("input[name=dispatch]").val('orders.repay');
				requestCardNonce();
				return false;
			} else {
console.log("Repay: submitted order without Nonce: sq_payment="+sq_payment+", sq_nonce_used="+sq_nonce_used);
				return true;
			}
		});

sq_dbg && console.log("Click event set for id="+but_id);
	});
</script>
{/if} {** sq_application_id **}
